
// DlgProxy.cpp : implementation file
//

#include "pch.h"
#include "framework.h"
#include "SASDKMFC.h"
#include "DlgProxy.h"
#include "SASDKMFCDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSASDKMFCDlgAutoProxy

IMPLEMENT_DYNCREATE(CSASDKMFCDlgAutoProxy, CCmdTarget)

CSASDKMFCDlgAutoProxy::CSASDKMFCDlgAutoProxy()
{
	EnableAutomation();

	// To keep the application running as long as an automation
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT_VALID(AfxGetApp()->m_pMainWnd);
	if (AfxGetApp()->m_pMainWnd)
	{
		ASSERT_KINDOF(CSASDKMFCDlg, AfxGetApp()->m_pMainWnd);
		if (AfxGetApp()->m_pMainWnd->IsKindOf(RUNTIME_CLASS(CSASDKMFCDlg)))
		{
			m_pDialog = reinterpret_cast<CSASDKMFCDlg*>(AfxGetApp()->m_pMainWnd);
			m_pDialog->m_pAutoProxy = this;
		}
	}
}

CSASDKMFCDlgAutoProxy::~CSASDKMFCDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != nullptr)
		m_pDialog->m_pAutoProxy = nullptr;
	AfxOleUnlockApp();
}

void CSASDKMFCDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CSASDKMFCDlgAutoProxy, CCmdTarget)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CSASDKMFCDlgAutoProxy, CCmdTarget)
END_DISPATCH_MAP()

// Note: we add support for IID_ISASDKMFC to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the
//  dispinterface in the .IDL file.

// {7c5fc49f-70ca-410f-8e01-08997cb2baf4}
static const IID IID_ISASDKMFC =
{0x7c5fc49f,0x70ca,0x410f,{0x8e,0x01,0x08,0x99,0x7c,0xb2,0xba,0xf4}};

BEGIN_INTERFACE_MAP(CSASDKMFCDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CSASDKMFCDlgAutoProxy, IID_ISASDKMFC, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in pch.h of this project
// {adfe653c-f2f7-406b-80dc-d38c80166438}
IMPLEMENT_OLECREATE2(CSASDKMFCDlgAutoProxy, "SASDKMFC.Application", 0xadfe653c,0xf2f7,0x406b,0x80,0xdc,0xd3,0x8c,0x80,0x16,0x64,0x38)


// CSASDKMFCDlgAutoProxy message handlers
