
// SASDKMFCDlg.cpp : implementation file
//

#include "pch.h"
#include "framework.h"
#include "SASDKMFC.h"
#include "SASDKMFCDlg.h"
#include "DlgProxy.h"
#include "afxdialogex.h"
#include "SDKHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CSASDKMFCDlg dialog


IMPLEMENT_DYNAMIC(CSASDKMFCDlg, CDialogEx);

CSASDKMFCDlg::CSASDKMFCDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_SASDKMFC_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = nullptr;
}

CSASDKMFCDlg::~CSASDKMFCDlg()
{
	NRKSdk.ReleaseDispatch();

	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to null, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != nullptr)
		m_pAutoProxy->m_pDialog = nullptr;
}

void CSASDKMFCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSASDKMFCDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_CLOSE()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CSASDKMFCDlg::OnBnClickedConnect)
	ON_BN_CLICKED(IDC_BUTTON15, &CSASDKMFCDlg::OnBnClickedDisconnect) // olga XIT-849 - allow to control connection to SA SDK engine
	ON_BN_CLICKED(IDC_BUTTON2, &CSASDKMFCDlg::OnBnClickedTest)
	ON_BN_CLICKED(IDC_BUTTON3, &CSASDKMFCDlg::OnBnClickedGetTransform)
	ON_BN_CLICKED(IDC_BUTTON4, &CSASDKMFCDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON5, &CSASDKMFCDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CSASDKMFCDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON7, &CSASDKMFCDlg::OnBnClickedButton7)
	ON_BN_CLICKED(IDC_BUTTON8, &CSASDKMFCDlg::OnBnClickedButton8)
	ON_BN_CLICKED(IDC_BUTTON9, &CSASDKMFCDlg::OnBnClickedButton9)
	ON_BN_CLICKED(IDC_BUTTON10, &CSASDKMFCDlg::OnBnClickedButton10)   // olga mantis #7823
	ON_BN_CLICKED(IDC_BUTTON11, &CSASDKMFCDlg::OnBnClickedButton11)   // olga JIRA XIT-311
	ON_BN_CLICKED(IDC_BUTTON12, &CSASDKMFCDlg::OnBnClickedButton12)   // olga JIRA XIT-659
	ON_BN_CLICKED(IDC_BUTTON13, &CSASDKMFCDlg::OnBnClickedButton13)   // olga 2017.12.08 XIT-917 - transition to new SA Colorizer
	ON_BN_CLICKED(IDC_BUTTON14, &CSASDKMFCDlg::OnBnClickedButton14)   // olga XIT-1135 - Test for Set/Get multi-line notes (EditText MP Argument)  
	ON_BN_CLICKED(IDC_BUTTON16, &CSASDKMFCDlg::OnBnClickedButton16)   // olga XIT-1214
	ON_BN_CLICKED(IDC_BUTTON17, &CSASDKMFCDlg::OnBnClickedButton17)   // olga XIT-1024
	ON_BN_CLICKED(IDC_BUTTON18, &CSASDKMFCDlg::OnBnClickedButton18)   // olga XIT-1213
	ON_BN_CLICKED(IDC_BUTTON19, &CSASDKMFCDlg::OnBnClickedButton19)
	ON_BN_CLICKED(IDC_BUTTON20, &CSASDKMFCDlg::OnBnClickedButton20)
	ON_BN_CLICKED(IDC_BUTTON21, &CSASDKMFCDlg::OnBnClickedButton21)   // olga XIT-2275 / XIT-2824 - test Export ASCII Frames/ASCII Import
	ON_BN_CLICKED(IDC_BUTTON22, &CSASDKMFCDlg::OnBnClickedButton22)
	ON_BN_CLICKED(IDC_BUTTON23, &CSASDKMFCDlg::OnBnClickedButton23)
	ON_BN_CLICKED(IDC_BUTTON24, &CSASDKMFCDlg::OnBnClickedButton24) // olga XIT-2789
	ON_BN_CLICKED(IDC_BUTTON25, &CSASDKMFCDlg::OnBnClickedButton25)
END_MESSAGE_MAP()


// CSASDKMFCDlg message handlers

BOOL CSASDKMFCDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_SDKConnected = FALSE; // olga XIT-849
	m_SDKDispatchCreated = FALSE;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSASDKMFCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSASDKMFCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSASDKMFCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void CSASDKMFCDlg::OnClose()
{
	if (CanExit())
		CDialogEx::OnClose();
}

void CSASDKMFCDlg::OnOK()
{
	if (CanExit())
		CDialogEx::OnOK();
}

void CSASDKMFCDlg::OnCancel()
{
	if (CanExit())
		CDialogEx::OnCancel();
}

BOOL CSASDKMFCDlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != nullptr)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}

//******************************************************
//******************************************************
void CSASDKMFCDlg::OnBnClickedConnect()
{
    if (!m_SDKDispatchCreated)
    {
        if (!NRKSdk.CreateDispatch(_T("SpatialAnalyzerSDK.Application")))
        {
            AfxMessageBox(_T("Failed to CreateDispatch"));
            m_SDKConnected = FALSE;
        }
        else
            m_SDKDispatchCreated = TRUE;
    }

    if (m_SDKDispatchCreated)
    {
        if (!m_SDKConnected)
        {
            if (!NRKSdk.Connect(_T("localhost")))           // olga - adjusted IP address
            {
                AfxMessageBox(_T("Failed to Connect"));
            }
            else
                m_SDKConnected = TRUE;
        }
    }
}

//*************************************************************
// olga XIT-849 - release SA SDK OLE dispatch
//*************************************************************
void CSASDKMFCDlg::OnBnClickedDisconnect() // olga XIT-849
{
    if (m_SDKDispatchCreated)
    {
        NRKSdk.ReleaseDispatch();

        m_SDKConnected = FALSE;         // olga XIT-849
        m_SDKDispatchCreated = FALSE;
    }

    // If there is an automation proxy for this dialog, set
    //  its back pointer to this dialog to NULL, so it knows
    //  the dialog has been deleted.
    if (m_pAutoProxy != NULL)
        m_pAutoProxy->m_pDialog = NULL;
}

void CSASDKMFCDlg::OnBnClickedTest()
{
    // *******************************************************************************************************
    // Reporting Operations >> Notify User String
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Notify User String"));
    NRKSdk.SetStringArg(_T("Notification Text"), _T("Spatial Analyzer SDK Sample.  Engineered for Extreme Measures."));
    NRKSdk.SetFontTypeArg(_T("Font"), _T("Arial"), 24, 255, 0, 0);
    NRKSdk.ExecuteStep();
    // *******************************************************************************************************

    NRKSdk.SetStep(_T("Set View Idle Update Frequency"));
    NRKSdk.SetIntegerArg(_T("Idle Count"), 10000);
    NRKSdk.ExecuteStep();

    DWORD TimeStart, TimeStop;
    int nbIteration = 20;
    int granularity = 5;
    CString errorMessage;
    CString pointCollectionName, pointGroupName, pointName;
    TimeStart = ::GetTickCount();
    bool bAbort = false;
    for (int col = 0; !bAbort && col < nbIteration; ++col)
    {
        pointCollectionName.Format(_T("collection%d"), col);
        for (int group = 0; !bAbort && group < nbIteration; ++group)
        {
            pointGroupName.Format(_T("group%d"), group);
            for (int i = 0; !bAbort && i < nbIteration; ++i)
            {
                pointName.Format(_T("point%d"), i);
                double x = col;
                double y = group;
                double z = i;
                NRKSdk.SetStep(_T("Construct a Point in Working Coordinates"));
                NRKSdk.SetPointNameArg(_T("Point Name"), pointCollectionName, pointGroupName, pointName);
                NRKSdk.SetVectorArg(_T("Working Coordinates"), x, y, z);

                DWORD _TimeStart = ::GetTickCount();
                BOOL bSendStatus = NRKSdk.ExecuteStep();
                DWORD _TimeStop = ::GetTickCount();
                //DWORD _Duration = _TimeStop - _TimeStart;
                //TRACE1("Construct Point Duration (MS): %d\n", _Duration);
                if (bSendStatus)
                {
                    LONG rCode;
                    NRKSdk.GetMPStepResult(&rCode);
                    if (rCode == SdkError)
                    {
                        CStringArray msgs;
                        // Something went wrong... check for any messages provided...
                        SDKHelper	helper(NRKSdk);
                        if (helper.GetMPStepMessagesHelper(msgs))
                        {
                            CString singleLine;
                            for (int i = 0; i < msgs.GetSize(); i++)
                            {
                                singleLine += msgs[i];
                                singleLine += _T("\r\n");
                            }
                            AfxMessageBox(singleLine);
                        }
                    }
                }
                else
                {
                    CString msg;
                    msg.Format(_T("Failed to send: Construct a Point in Working Coordinates %s::%s::%s\nContinue?"), pointCollectionName, pointGroupName, pointName);
                    if (AfxMessageBox(msg, MB_OKCANCEL | MB_ICONQUESTION) == IDCANCEL)
                    {
                        bAbort = true;
                    }
                }
            }
        }
    }
    TimeStop = ::GetTickCount();
    DWORD Duration = TimeStop - TimeStart;
    if (!bAbort)
    {
        CString msg;
        msg.Format(_T("Construct %d Points Duration (MS): %d"), nbIteration * nbIteration * nbIteration, Duration);
        //TRACE1("Construct Point ALL Duration (MS): %d\n", Duration);
        AfxMessageBox(msg);
        MessageBeep(-1);
    }
    else
    {
        return;
    }

    NRKSdk.SetStep(_T("Set View Idle Update Frequency"));
    NRKSdk.SetIntegerArg(_T("Idle Count"), 1000);
    NRKSdk.ExecuteStep();

    // *******************************************************************************************************
    // Construction Operations >> Points and Groups >> Construct a Point in Working Coordinates 
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Construct a Point in Working Coordinates"));
    NRKSdk.SetVectorArg(_T("Working Coordinates"), 10.1234, 20.2345, 30.5678);
    NRKSdk.SetPointNameArg(_T("Point Name"), _T(""), _T("TestGrp"), _T("TestPt"));
    BOOL bSendStatus = NRKSdk.ExecuteStep();
    // *******************************************************************************************************

    // *******************************************************************************************************
    // Process Flow Operations >> Ask for String
    // NOTE: Example illustrates attempting to execute a MP Step with an invalid argument
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Ask for String"));
    NRKSdk.SetStringArg(_T("Question to ask"), _T("Enter Sphere Name"));
    // NOTE: Should be "Initial Answer"... mistake added for error checking!
    NRKSdk.SetStringArg(_T("Initial Value"), _T("MySphere"));
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == SdkError)
        {
            CStringArray msgs;
            // Something went wrong... check for any messages provided...
            SDKHelper	helper(NRKSdk);
            if (helper.GetMPStepMessagesHelper(msgs))
            {
                CString singleLine;
                for (int i = 0; i < msgs.GetSize(); i++)
                {
                    singleLine += msgs[i];
                    singleLine += _T("\r\n");
                }
                AfxMessageBox(singleLine);
            }
        }
    }
    // *******************************************************************************************************

    // *******************************************************************************************************
    // Process Flow Operations >> Ask for String
    // NOTE: This attempt has the proper parameters
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Ask for String"));
    NRKSdk.SetStringArg(_T("Question to ask"), _T("Enter Sphere Name"));
    NRKSdk.SetStringArg(_T("Initial Answer"), _T("MySphere"));
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode != DoneSuccess)
        {
            return;
        }
    }

    // Now get the answer
    CString sphereName;
    CComBSTR name;
    if (bSendStatus && NRKSdk.GetStringArg(_T("Answer"), &name))
    {
        sphereName = name;
        CString msg;
        msg.Format(_T("Sphere Name Entered: %s"), sphereName);
        AfxMessageBox(msg);
    }
    // Must release the BSTR returned.
    name.Empty();
    // *******************************************************************************************************

    // *******************************************************************************************************
    // Process Flow Operations >> Ask for Double
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Ask for Double"));
    NRKSdk.SetStringArg(_T("Question to ask"), _T("Enter Sphere Radius"));
    NRKSdk.SetDoubleArg(_T("Initial Value"), 11.5);
    bSendStatus = NRKSdk.ExecuteStep();

    DOUBLE radius;
    if (bSendStatus && NRKSdk.GetDoubleArg(_T("Answer"), &radius))
    {
        CString msg;
        msg.Format(_T("Radius Value Entered: %f"), radius);
        AfxMessageBox(msg);
    }
    // *******************************************************************************************************

    // *******************************************************************************************************
    // Construction Operations >> Spheres >> Construct Sphere
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Construct Sphere"));
    NRKSdk.SetObjectNameArg(_T("Sphere Name"), sphereName);
    NRKSdk.SetVectorArg(_T("Sphere Center (in working coordinates)"), 6.0, 12.0, 18.0);
    NRKSdk.SetDoubleArg(_T("Sphere Radius"), radius);
    bSendStatus = NRKSdk.ExecuteStep();
    // *******************************************************************************************************

    // *******************************************************************************************************
    // Construction Operations >> Points and Groups >> Construct Point at Object Origin
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Construct Point at Object Origin"));
    NRKSdk.SetCollectionObjectNameArg(_T("Object Name"), _T(""), sphereName);
    NRKSdk.SetPointNameArg(_T("Resultant Point Name"), _T(""), _T("TestGrp"), _T("ObjOrgPt"));
    bSendStatus = NRKSdk.ExecuteStep();

    // This section illustrates getting return values from the successfully sent MP Step
    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            // The command executed successfully, now get the return values and display to user
            DOUBLE val;
            if (bSendStatus && NRKSdk.GetDoubleArg(_T("X Value"), &val))
            {
                CString msg;
                msg.Format(_T("X Value: %f"), val);
                AfxMessageBox(msg);
            }

            if (bSendStatus && NRKSdk.GetDoubleArg(_T("Y Value"), &val))
            {
                CString msg;
                msg.Format(_T("Y Value: %f"), val);
                AfxMessageBox(msg);
            }

            if (bSendStatus && NRKSdk.GetDoubleArg(_T("Z Value"), &val))
            {
                CString msg;
                msg.Format(_T("Z Value: %f"), val);
                AfxMessageBox(msg);
            }

            DOUBLE xVal, yVal, zVal;
            if (bSendStatus && NRKSdk.GetVectorArg(_T("Vector Representation"), &xVal, &yVal, &zVal))
            {
                CString msg;
                msg.Format(_T("Vector Value: %f %f %f"), xVal, yVal, zVal);
                AfxMessageBox(msg);
            }
        }
    }
    // *******************************************************************************************************

    // *******************************************************************************************************
    // Construction Operations >> Other MP Types >> Make a Transform from Doubles (Fixed XYZ)
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Make a Transform from Doubles (Fixed XYZ)"));
    NRKSdk.SetDoubleArg(_T("X"), 10.0);
    NRKSdk.SetDoubleArg(_T("Y"), 30.0);
    NRKSdk.SetDoubleArg(_T("Z"), 50.0);
    NRKSdk.SetDoubleArg(_T("Rx (Roll)"), 40.0);
    NRKSdk.SetDoubleArg(_T("Ry (Pitch)"), -30.0);
    NRKSdk.SetDoubleArg(_T("Rz (Yaw)"), -60.0);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        SDKHelper helper(NRKSdk);

        double T[4][4];
        if (helper.GetTransformArgHelper(_T("Resultant Transform"), T))
        {
            // *******************************************************************************************************
            // Construction Operations >> Frames >> Construct Frame
            // *******************************************************************************************************
            NRKSdk.SetStep(_T("Construct Frame"));
            NRKSdk.SetCollectionObjectNameArg(_T("New Frame Name"), _T(""), _T("Test Frame"));
            // Use the helper object to make life easier when setting a transform argument
            helper.SetTransformArgHelper(_T("Transform in Working Coordinates"), T);
            bSendStatus = NRKSdk.ExecuteStep();
            // *******************************************************************************************************
        }
    }
    // *******************************************************************************************************

    // *******************************************************************************************************
    // Construction Operations >> Other MP Types >> Get Working Transform of Object (Fixed XYZ)
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Get Working Transform of Object (Fixed XYZ)"));
    NRKSdk.SetCollectionObjectNameArg(_T("Object Name"), _T(""), sphereName);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            SDKHelper helper(NRKSdk);
            double T[4][4];
            if (helper.GetTransformArgHelper(_T("Transform"), T))
            {
                helper.DebugMatrix(T);
            }
        }
    }
    // *******************************************************************************************************

    // *******************************************************************************************************
    // Instrument Operations >> Add New Instrument
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Add New Instrument"));
    NRKSdk.SetInstTypeNameArg(_T("Instrument Type"), _T("API Tracker III"));
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            long instId;
            NRKSdk.GetInstIdArg(_T("Instrument Added (result)"), &instId);
        }
    }
    // *******************************************************************************************************

    // *******************************************************************************************************
    // Instrument Operations >> Get Instrument Transform
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Get Instrument Transform"));
    NRKSdk.SetColInstIdArg(_T("Instrument ID"), _T(""), 0);
    NRKSdk.SetCollectionObjectNameArg(_T("Reference Frame"), _T(""), _T("WORLD"));
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            SDKHelper helper(NRKSdk);
            double T[4][4];
            if (helper.GetTransformArgHelper(_T("Transform"), T))
            {
                helper.DebugMatrix(T);
            }
        }
    }
    // *******************************************************************************************************

    // *******************************************************************************************************
    // Instrument Operations >> Get Last Instrument Index
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Get Last Instrument Index"));
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            long instId;
            if (NRKSdk.GetInstIdArg(_T("Instrument ID"), &instId))
            {

            }
            CComBSTR colName;
            if (NRKSdk.GetColInstIdArg(_T("Instrument ID"), &colName, &instId))
            {

            }
            colName.Empty();
        }
    }
    // *******************************************************************************************************

    // *******************************************************************************************************
    // View Control >> Hide Objects
    // *******************************************************************************************************
    CStringArray objNameList;
    CString item;
    item.Format(_T("%s::%s"), _T("A"), _T("Test Frame"));
    objNameList.Add(item);
    item.Format(_T("%s::%s"), _T("A"), sphereName);
    objNameList.Add(item);

    NRKSdk.SetStep(_T("Hide Objects"));
    {
        SDKHelper helper(NRKSdk);
        helper.SetCollectionObjectNameRefListArgHelper(_T("Objects To Hide"), objNameList);
    }
    bSendStatus = NRKSdk.ExecuteStep();
    // *******************************************************************************************************

    // *******************************************************************************************************
    // Construction Operations >> Other MP Types >> Make a Collection Object Name Reference List- Runtime Select
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Make a Collection Object Name Reference List- Runtime Select"));
    NRKSdk.SetStringArg(_T("User Prompt"), _T("Select Some Objects"));
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            SDKHelper helper(NRKSdk);
            CStringArray objNames;
            // Get and display the selected objects to the user
            if (helper.GetCollectionObjectNameRefListArgHelper(_T("Resultant Collection Object Name Reference List"), objNames))
            {
                for (INT_PTR row = 0; row < objNames.GetSize(); row++)
                {
                    TRACE1("%s\n", objNames[row]);
                }
                TRACE("\n");
            }
        }
    }
    // *******************************************************************************************************

    // *******************************************************************************************************
    // Construction Operations >> Other MP Types >> Make a Point Name Ref List - Runtime Select
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Make a Point Name Ref List - Runtime Select"));
    NRKSdk.SetStringArg(_T("User Prompt"), _T("Select Some Points"));
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            SDKHelper helper(NRKSdk);
            CStringArray ptNames;
            // Get and display the selected objects to the user
            if (helper.GetPointNameRefListArgHelper(_T("Resultant Point Name List"), ptNames))
            {
                for (INT_PTR row = 0; row < ptNames.GetSize(); row++)
                {
                    TRACE1("%s\n", ptNames[row]);
                }
                TRACE("\n");
            }
        }
    }
    // *******************************************************************************************************

    // *******************************************************************************************************
    // Construction Operations >> Other MP Types >> Append two Point Name Ref Lists
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Append two Point Name Ref Lists"));
    CStringArray ptNameListA;
    ptNameListA.Add(_T("A::Random::r2"));
    ptNameListA.Add(_T("A::Random::r4"));
    ptNameListA.Add(_T("A::Random::r6"));
    ptNameListA.Add(_T("A::Random::r8"));
    ptNameListA.Add(_T("A::Random::r10"));
    SDKHelper ptArrayHelper(NRKSdk);
    ptArrayHelper.SetPointNameRefListArgHelper(_T("Point Name List A"), ptNameListA);
    CStringArray ptNameListB;
    ptNameListB.Add(_T("A::Random1::r1"));
    ptNameListB.Add(_T("A::Random1::r3"));
    ptNameListB.Add(_T("A::Random1::r5"));
    ptNameListB.Add(_T("A::Random1::r7"));
    ptNameListB.Add(_T("A::Random1::r9"));
    ptNameListB.Add(_T("A::Random1::r11"));
    ptArrayHelper.SetPointNameRefListArgHelper(_T("Point Name List B"), ptNameListB);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            SDKHelper helper(NRKSdk);
            CStringArray resultingNameList;
            // Get and display the selected objects to the user
            if (helper.GetPointNameRefListArgHelper(_T("Resultant Point Name List(A+B)"), resultingNameList))
            {
                for (INT_PTR row = 0; row < resultingNameList.GetSize(); row++)
                {
                    TRACE1("%s\n", resultingNameList[row]);
                }
                TRACE("\n");
            }
        }
    }
    // *******************************************************************************************************

    // *******************************************************************************************************
    // Analysis Operations >> Best Fit Transformation - Group to Group (Scale Free)
    // *******************************************************************************************************
    NRKSdk.SetStep(_T("Best Fit Transformation - Group to Group (Scale Free)"));
    NRKSdk.SetCollectionObjectNameArg(_T("Reference Group"), _T(""), _T("Random"));
    NRKSdk.SetCollectionObjectNameArg(_T("Corresponding Group"), _T(""), _T("Random1"));
    NRKSdk.SetDoubleArg(_T("Show Interface"), TRUE);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            SDKHelper helper(NRKSdk);
            double T[4][4];
            if (helper.GetTransformArgHelper(_T("Transform in Working"), T))
            {
                helper.DebugMatrix(T);
            }
            TRACE("\n");
            double scale;
            if (helper.GetWorldTransformArgHelper(_T("Optimum Transform"), T, scale))
            {
                helper.DebugMatrix(T);
            }
            TRACE(_T("Scale: %.*f\n"), 4, scale);
        }
    }
    // *******************************************************************************************************
}


void CSASDKMFCDlg::OnBnClickedGetTransform()
{
    BOOL bSendStatus(FALSE);

    NRKSdk.SetStep(_T("Run Subroutine"));
    NRKSdk.SetFilePathArg(_T("MP Subroutine File Path"), _T("A::add subroutine.mp"), FALSE);
    NRKSdk.SetBoolArg(_T("Share Parent Variables?"), FALSE);
    NRKSdk.SetDoubleArg(_T("Doub 1"), 10.0);
    NRKSdk.SetDoubleArg(_T("Doub 2"), 30.0);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        double sum;

        if (NRKSdk.GetDoubleArg(_T("Sum"), &sum))
        {
            CString msg;
            msg.Format(_T("Sum: %d"), sum);
            AfxMessageBox(msg);
        }
        else
            AfxMessageBox(_T("Subroutine call failed"));
    }
}


void CSASDKMFCDlg::OnBnClickedButton4()
{
    NRKSdk.SetStep(_T("Perform Robot Calibration (Alternate)"));
    NRKSdk.SetColMachineIdArg(_T("Machine ID"), _T(""), 0);
    NRKSdk.SetStringArg(_T("Calibration Name"), _T("NRK Lab Cal 1"));
    NRKSdk.SetStringArg(_T("BASE Degrees of Freedom"), _T("6 DOF"));
    NRKSdk.SetStringArg(_T("ROBOT Degrees of Freedom"), _T("Full"));
    NRKSdk.SetStringArg(_T("TOOL Degrees of Freedom"), _T("6 DOF"));
    NRKSdk.SetBoolArg(_T("Show Interface"), TRUE);
    NRKSdk.ExecuteStep();

    DOUBLE value;
    CString results;
    CString result;

    NRKSdk.GetDoubleArg(_T("XYZ Max"), &value);        result.Format(_T("XYZ Max       :%0.6f\n"), value); results += result;
    NRKSdk.GetDoubleArg(_T("XYZ Average"), &value);    result.Format(_T("XYZ Average   :%0.6f\n"), value); results += result;
    NRKSdk.GetDoubleArg(_T("XYZ RMS"), &value);        result.Format(_T("XYZ RMS       :%0.6f\n"), value); results += result;
    NRKSdk.GetDoubleArg(_T("Orient Max"), &value);     result.Format(_T("Orient Max    :%0.6f\n"), value); results += result;
    NRKSdk.GetDoubleArg(_T("Orient Average"), &value); result.Format(_T("Orient Average:%0.6f\n"), value); results += result;
    NRKSdk.GetDoubleArg(_T("Orient RMS"), &value);     result.Format(_T("Orient RMS    :%0.6f\n"), value); results += result;
    NRKSdk.GetDoubleArg(_T("Robustness"), &value);     result.Format(_T("Robustness    :%0.6f\n"), value); results += result;
    TRACE(results);
}


void CSASDKMFCDlg::OnBnClickedButton5()
{
    NRKSdk.SetStep(_T("Construct Frame, 3 Points"));
    NRKSdk.SetStringArg(_T("Construction Method"), _T("Origin,X,XY"));
    NRKSdk.SetPointNameArg(_T("Origin Point"), _T("A"), _T("Robot Calibration Data"), _T("pose0"));
    NRKSdk.SetPointNameArg(_T("Primary Axis Point"), _T("A"), _T("Robot Calibration Data"), _T("pose1"));
    NRKSdk.SetPointNameArg(_T("Secondary Axis Point"), _T("A"), _T("Robot Calibration Data"), _T("pose2"));
    NRKSdk.SetFrameNameArg(_T("Frame Name (Optional)"), _T("New Frame"));
    NRKSdk.ExecuteStep();
}


void CSASDKMFCDlg::OnBnClickedButton6()
{
    NRKSdk.SetStep(_T("Import Poses Match to Frames"));
    NRKSdk.SetColMachineIdArg(_T("Machine ID"), _T(""), 0);
    NRKSdk.SetStringArg(_T("Calibration Name"), _T("Cal Set 4"));
    CStringArray objNameList;
    objNameList.Add(_T("6DOFMeas::jn_1::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_2::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_3::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_4::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_5::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_6::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_7::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_8::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_9::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_10::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_11::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_12::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_13::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_14::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_15::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_16::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_17::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_18::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_19::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_20::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_21::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_22::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_23::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_24::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_25::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_26::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_27::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_28::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_29::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_30::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_31::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_32::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_33::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_34::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_35::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_36::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_37::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_38::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_39::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_40::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_41::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_42::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_43::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_44::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_45::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_46::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_47::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_48::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_49::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_50::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_51::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_52::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_53::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_54::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_55::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_56::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_57::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_58::Frame"));
    objNameList.Add(_T("6DOFMeas::jn_59::Frame"));
    SDKHelper helper(NRKSdk);
    helper.SetCollectionObjectNameRefListArgHelper(_T("Frame Names"), objNameList);
    NRKSdk.SetFilePathArg(_T("FilePath for CSV Joint Set File"), _T("C:\\WUSave\\Joint Set File.csv"), TRUE);
    NRKSdk.ExecuteStep();

}


void CSASDKMFCDlg::OnBnClickedButton7()
{
    BOOL bSendStatus = FALSE;

    NRKSdk.SetStep(_T("Get Robot Pose for a Frame"));
    NRKSdk.SetColMachineIdArg(_T("Machine ID"), _T("A"), 0);
    NRKSdk.SetCollectionObjectNameArg(_T("Goal Frame"), _T("A"), _T("Target Frame"));

    double refPose[6] = { 77, -100, 40, -125, 60, 110 };
    long   refSize = 6;

    SDKHelper helper(NRKSdk);

    if (helper.SetDoubleArrayArgHelper(_T("Reference Pose"), refSize, refPose))
    {
        bSendStatus = NRKSdk.ExecuteStep();

        if (bSendStatus)
        {
            double goalPose[6] = { 0, 0, 0, 0, 0, 0 };
            long goalSize(0);

            if (helper.GetDoubleArrayArgHelper(_T("Goal Pose"), goalSize, goalPose))
            {
                CString msg;

                msg.Format(_T("%0.3f, %0.3f, %0.3f, %0.3f, %0.3f, %0.3f"),
                    goalPose[0], goalPose[1], goalPose[2], goalPose[3], goalPose[4], goalPose[5]);

                AfxMessageBox(msg);
            }
            else
                AfxMessageBox(_T("NRKSdk.ExecuteStep failed"));
        }
        else
            AfxMessageBox(_T("helper.GetDoubleArrayArgHelper failed"));
    }
    else
        AfxMessageBox(_T("helper.SetDoubleArrayArgHelper failed"));

    return;

#  ifdef NEVER

    NRKSdk.SetStep(_T("Set Object to Object Direction Relationship Tolerances"));
    NRKSdk.SetCollectionObjectNameArg(_T("Relationship Name"), _T("A"), _T("Direction - Line To Random"));
    NRKSdk.SetToleranceScalarOptionsArg(_T("Angle Between Vectors Tolerances"), TRUE, 0.500000, TRUE, 0.500000);
    NRKSdk.SetToleranceScalarOptionsArg(_T("Mutual Perpendicular Length Tolerances"), TRUE, 0.500000, TRUE, 0.500000);
    NRKSdk.ExecuteStep();

#  endif

    NRKSdk.SetStep(_T("Auto Filter Points/Groups/Clouds to Surface Faces"));
    CStringArray ptNameList;
    ptNameList.Add(_T("A::Probed::P1"));
    ptNameList.Add(_T("A::Probed::P2"));
    ptNameList.Add(_T("A::Probed::P3"));
    ptNameList.Add(_T("A::Probed::P4"));
    ptNameList.Add(_T("A::Probed::P5"));
    ptNameList.Add(_T("A::Probed::P6"));
    ptNameList.Add(_T("A::Probed::P7"));
    ptNameList.Add(_T("A::Probed::P8"));
    ptNameList.Add(_T("A::Probed::P9"));
    ptNameList.Add(_T("A::Probed::P10"));
    ptNameList.Add(_T("A::Probed::P11"));
    ptNameList.Add(_T("A::Probed::P12"));
    ptNameList.Add(_T("A::Probed::P13"));
    ptNameList.Add(_T("A::Probed::P14"));
    ptNameList.Add(_T("A::Probed::P15"));
    ptNameList.Add(_T("A::Probed::P16"));
    ptNameList.Add(_T("A::Probed::P17"));
    ptNameList.Add(_T("A::Probed::P18"));
    ptNameList.Add(_T("A::Probed::P19"));
    ptNameList.Add(_T("A::Probed::P20"));
    ptNameList.Add(_T("A::Probed::P21"));
    ptNameList.Add(_T("A::Probed::P22"));
    ptNameList.Add(_T("A::Probed::P23"));
    ptNameList.Add(_T("A::Probed::P24"));
    ptNameList.Add(_T("A::Probed::P25"));
    ptNameList.Add(_T("A::Probed::P26"));
    ptNameList.Add(_T("A::Probed::P27"));
    ptNameList.Add(_T("A::Probed::P28"));
    ptNameList.Add(_T("A::Probed::P29"));
    ptNameList.Add(_T("A::Probed::P30"));
    ptNameList.Add(_T("A::Probed::P31"));
    ptNameList.Add(_T("A::Probed::P32"));
    ptNameList.Add(_T("A::Probed::P33"));
    ptNameList.Add(_T("A::Probed::P34"));
    ptNameList.Add(_T("A::Probed::P35"));
    ptNameList.Add(_T("A::Probed::P36"));
    ptNameList.Add(_T("A::Probed::P37"));
    ptNameList.Add(_T("A::Probed::P38"));
    ptNameList.Add(_T("A::Probed::P39"));
    ptNameList.Add(_T("A::Probed::P40"));
    ptNameList.Add(_T("A::Probed::P41"));
    ptNameList.Add(_T("A::Probed::P42"));
    ptNameList.Add(_T("A::Probed::P43"));
    ptNameList.Add(_T("A::Probed::P44"));
    ptNameList.Add(_T("A::Probed::P45"));
    ptNameList.Add(_T("A::Probed::P46"));
    ptNameList.Add(_T("A::Probed::P47"));
    ptNameList.Add(_T("A::Probed::P48"));
    ptNameList.Add(_T("A::Probed::P49"));
    ptNameList.Add(_T("A::Probed::P50"));
    ptNameList.Add(_T("A::Probed::P51"));
    ptNameList.Add(_T("A::Probed::P52"));
    ptNameList.Add(_T("A::Probed::P53"));
    ptNameList.Add(_T("A::Probed::P54"));
    ptNameList.Add(_T("A::Probed::P55"));
    ptNameList.Add(_T("A::Probed::P56"));
    ptNameList.Add(_T("A::Probed::P57"));
    ptNameList.Add(_T("A::Probed::P58"));
    ptNameList.Add(_T("A::Probed::P59"));
    ptNameList.Add(_T("A::Probed::P60"));
    ptNameList.Add(_T("A::Probed::P61"));
    ptNameList.Add(_T("A::Probed::P62"));
    ptNameList.Add(_T("A::Probed::P63"));
    ptNameList.Add(_T("A::Probed::P64"));
    ptNameList.Add(_T("A::Probed::P65"));
    ptNameList.Add(_T("A::Probed::P66"));
    ptNameList.Add(_T("A::Probed::P67"));
    ptNameList.Add(_T("A::Probed::P68"));
    ptNameList.Add(_T("A::Probed::P69"));
    ptNameList.Add(_T("A::Probed::P70"));
    ptNameList.Add(_T("A::Probed::P71"));
    ptNameList.Add(_T("A::Probed::P72"));
    ptNameList.Add(_T("A::Probed::P73"));
    ptNameList.Add(_T("A::Probed::P74"));
    ptNameList.Add(_T("A::Probed::P75"));
    ptNameList.Add(_T("A::Probed::P76"));
    ptNameList.Add(_T("A::Probed::P77"));
    ptNameList.Add(_T("A::Probed::P78"));
    ptNameList.Add(_T("A::Probed::P79"));
    ptNameList.Add(_T("A::Probed::P80"));
    ptNameList.Add(_T("A::Probed::P81"));
    ptNameList.Add(_T("A::Probed::P82"));
    ptNameList.Add(_T("A::Probed::P83"));
    ptNameList.Add(_T("A::Probed::P84"));
    ptNameList.Add(_T("A::Probed::P85"));
    ptNameList.Add(_T("A::Probed::P86"));
    ptNameList.Add(_T("A::Probed::P87"));
    ptNameList.Add(_T("A::Probed::P88"));
    ptNameList.Add(_T("A::Probed::P89"));
    ptNameList.Add(_T("A::Probed::P90"));
    ptNameList.Add(_T("A::Probed::P91"));
    ptNameList.Add(_T("A::Probed::P92"));
    ptNameList.Add(_T("A::Probed::P93"));
    ptNameList.Add(_T("A::Probed::P94"));
    ptNameList.Add(_T("A::Probed::P95"));
    ptNameList.Add(_T("A::Probed::P96"));
    ptNameList.Add(_T("A::Probed::P97"));
    ptNameList.Add(_T("A::Probed::P98"));
    ptNameList.Add(_T("A::Probed::P99"));
    ptNameList.Add(_T("A::Probed::P100"));
    ptNameList.Add(_T("A::Probed::P101"));
    ptNameList.Add(_T("A::Probed::P102"));
    ptNameList.Add(_T("A::Probed::P103"));
    ptNameList.Add(_T("A::Probed::P104"));
    ptNameList.Add(_T("A::Probed::P105"));
    ptNameList.Add(_T("A::Probed::P106"));
    ptNameList.Add(_T("A::QuickAlign::1"));
    ptNameList.Add(_T("A::QuickAlign::2"));
    ptNameList.Add(_T("A::QuickAlign::3"));
    ptNameList.Add(_T("A::QuickAlign::4"));
    ptNameList.Add(_T("A::QuickAlign::5"));
    ptNameList.Add(_T("A::QuickAlign::6"));
    ptNameList.Add(_T("A::QuickAlign::7"));
    ptNameList.Add(_T("A::QuickAlign::8"));
    ptNameList.Add(_T("A::QuickAlign::9"));
    ptNameList.Add(_T("A::QuickAlign::10"));
    ptNameList.Add(_T("A::QuickAlign::11"));
    ptNameList.Add(_T("A::QuickAlign::12"));
    ptNameList.Add(_T("A::QuickAlign::13"));
    ptNameList.Add(_T("A::QuickAlign::14"));

    helper.SetPointNameRefListArgHelper(_T("Points"), ptNameList);
    CStringArray objNameList;

    helper.SetCollectionObjectNameRefListArgHelper(_T("Groups"), objNameList);

    objNameList.RemoveAll();
    objNameList.Add(_T("A::Scan::Cloud"));

    helper.SetCollectionObjectNameRefListArgHelper(_T("Clouds"), objNameList);
    NRKSdk.SetDoubleArg(_T("Surface Offset"), 0.100000);
    NRKSdk.SetDoubleArg(_T("Edge Offset"), 0.100000);
    // Available options: 
    // "Both", "Positive only", "Negative only", 
    NRKSdk.SetOffsetDirectionTypeArg(_T("Offset Direction"), _T("Both"));
    NRKSdk.SetBoolArg(_T("Enforce Max Pts per Face in Output?"), FALSE);
    NRKSdk.SetIntegerArg(_T("Max Pts per Face"), 0);

    objNameList.RemoveAll();
    objNameList.Add(_T("A::Base::Surface"));
    objNameList.Add(_T("A::Vertical::Surface"));

    helper.SetCollectionObjectNameRefListArgHelper(_T("Surfaces"), objNameList);
    // Available options: 
    // "None", "Random", "Nth Point", 
    NRKSdk.SetCloudThinningOptionsArg(_T("Cloud Thinning Settings"), _T("Nth Point"), long(5), long(100), long(20000));
    NRKSdk.ExecuteStep();

#  ifdef NEVER

    NRKSdk.SetStep(_T("Set Relationship Tolerance (Scalar Type)"));
    NRKSdk.SetCollectionObjectNameArg(_T("Relationship Name"), _T("A"), _T("Points to Fitted Circle"));
    NRKSdk.SetToleranceScalarOptionsArg(_T("Tolerance Options"), TRUE, 0.500000, TRUE, 0.500000);
    NRKSdk.ExecuteStep();

    // ----

    NrkSdk.SetStep("Auto Filter Points/Groups/Clouds to Surface Faces");
    CStringArray ptNameList;
    SDKHelper helper(NrkSdk);
    helper.SetPointNameRefListArgHelper("Points", ptNameList);
    CStringArray objNameList;
    SDKHelper helper(NrkSdk);
    helper.SetCollectionObjectNameRefListArgHelper("Groups", objNameList);
    CStringArray objNameList;
    SDKHelper helper(NrkSdk);
    helper.SetCollectionObjectNameRefListArgHelper("Clouds", objNameList);
    NrkSdk.SetDoubleArg("Surface Offset", 0.100000);
    NrkSdk.SetDoubleArg("Edge Offset", 0.100000);
    // Available options: 
    // "Both", "Positive only", "Negative only", 
    NrkSdk.SetOffsetDirectionTypeArg("Offset Direction", "Both");
    NrkSdk.SetBoolArg("Enforce Max Pts per Face in Output?", FALSE);
    NrkSdk.SetIntegerArg("Max Pts per Face", 0);
    CStringArray objNameList;
    SDKHelper helper(NrkSdk);
    helper.SetCollectionObjectNameRefListArgHelper("Surfaces", objNameList);
    // Available options: 
    // "None", "Random", "Nth Point", 
    NrkSdk.SetCloudThinningOptionsArg("Cloud Thinning Settings", "Nth Point", 5, 100, 20000);
    NrkSdk.ExecuteStep();

#  endif

}


void CSASDKMFCDlg::OnBnClickedButton8()
{
    NRKSdk.SetStep(_T("Construct Frame"));
    NRKSdk.SetCollectionObjectNameArg(_T("New Frame Name"), _T(""), _T("Frame 1"));
    double T[4][4];
    T[0][0] = 0.813798; 	T[0][1] = -0.440970; 	T[0][2] = 0.378522; 	T[0][3] = 5.000000;
    T[1][0] = 0.469846; 	T[1][1] = 0.882564; 	T[1][2] = 0.018028; 	T[1][3] = 5.000000;
    T[2][0] = -0.342020; 	T[2][1] = 0.163176; 	T[2][2] = 0.925417; 	T[2][3] = 5.000000;
    T[3][0] = 0.000000; 	T[3][1] = 0.000000; 	T[3][2] = 0.000000; 	T[3][3] = 1.000000;

    SDKHelper helper(NRKSdk);
    helper.SetTransformArgHelper(_T("Transform in Working Coordinates"), T);
    NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Construct Frame"));
    NRKSdk.SetCollectionObjectNameArg(_T("New Frame Name"), _T(""), _T("Frame 2"));

    T[0][0] = 0.800235; 	T[0][1] = -0.446962; 	T[0][2] = 0.399811; 	T[0][3] = 10.000000;
    T[1][0] = 0.480829; 	T[1][1] = 0.876637; 	T[1][2] = 0.017627; 	T[1][3] = 10.000000;
    T[2][0] = -0.358368; 	T[2][1] = 0.178136; 	T[2][2] = 0.916428; 	T[2][3] = 10.000000;
    T[3][0] = 0.000000; 	T[3][1] = 0.000000; 	T[3][2] = 0.000000; 	T[3][3] = 1.000000;

    helper.SetTransformArgHelper(_T("Transform in Working Coordinates"), T);
    NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Make Scalar Tolerance"));
    NRKSdk.SetBoolArg(_T("Use High Tolerance"), TRUE);
    NRKSdk.SetDoubleArg(_T("High Tolerance"), 0.500000);
    NRKSdk.SetBoolArg(_T("Use Low Tolerance"), FALSE);
    NRKSdk.SetDoubleArg(_T("Low Tolerance"), 0.000000);
    NRKSdk.ExecuteStep();

    BOOL     bUseHigh;
    DOUBLE	highTol;
    BOOL     bUseLow;
    DOUBLE	lowTol;
    NRKSdk.GetToleranceScalarOptionsArg(_T("Resultant Tolerance Options"), &bUseHigh, &highTol, &bUseLow, &lowTol);

    NRKSdk.SetStep(_T("Make Vector Tolerance"));
    NRKSdk.SetBoolArg(_T("Use High X Tolerance"), TRUE);
    NRKSdk.SetDoubleArg(_T("High X Tolerance"), 10.000000);
    NRKSdk.SetBoolArg(_T("Use High Y Tolerance"), TRUE);
    NRKSdk.SetDoubleArg(_T("High Y Tolerance"), 11.000000);
    NRKSdk.SetBoolArg(_T("Use High Z Tolerance"), TRUE);
    NRKSdk.SetDoubleArg(_T("High Z Tolerance"), 12.000000);
    NRKSdk.SetBoolArg(_T("Use High Mag Tolerance"), TRUE);
    NRKSdk.SetDoubleArg(_T("High Mag Tolerance"), 13.000000);
    NRKSdk.SetBoolArg(_T("Use Low X Tolerance"), TRUE);
    NRKSdk.SetDoubleArg(_T("Low X Tolerance"), 1.000000);
    NRKSdk.SetBoolArg(_T("Use Low Y Tolerance"), TRUE);
    NRKSdk.SetDoubleArg(_T("Low Y Tolerance"), 2.000000);
    NRKSdk.SetBoolArg(_T("Use Low Z Tolerance"), TRUE);
    NRKSdk.SetDoubleArg(_T("Low Z Tolerance"), 3.000000);
    NRKSdk.SetBoolArg(_T("Use Low Mag Tolerance"), TRUE);
    NRKSdk.SetDoubleArg(_T("Low Mag Tolerance"), 4.000000);
    NRKSdk.ExecuteStep();

    BOOL	   bUseHighX;
    DOUBLE	highTolX;
    BOOL	   bUseHighY;
    DOUBLE	highTolY;
    BOOL	   bUseHighZ;
    DOUBLE	highTolZ;
    BOOL	   bUseHighM;
    DOUBLE	highTolM;
    BOOL	   bUseLowX;
    DOUBLE	lowTolX;
    BOOL	   bUseLowY;
    DOUBLE	lowTolY;
    BOOL	   bUseLowZ;
    DOUBLE	lowTolZ;
    BOOL	   bUseLowM;
    DOUBLE	lowTolM;
    NRKSdk.GetToleranceVectorOptionsArg(_T("Resultant Vector Tolerance"),
        &bUseHighX, &highTolX, &bUseHighY, &highTolY,
        &bUseHighZ, &highTolZ, &bUseHighM, &highTolM,
        &bUseLowX, &lowTolX, &bUseLowY, &lowTolY,
        &bUseLowZ, &lowTolZ, &bUseLowM, &lowTolM);

    NRKSdk.SetStep(_T("Make Frame to Frame Relationship"));
    NRKSdk.SetCollectionObjectNameArg(_T("Relationship Name"), _T(""), _T("Frame 1 to 2"));
    NRKSdk.SetCollectionObjectNameArg(_T("First Frame Name"), _T(""), _T("Frame 1"));
    NRKSdk.SetCollectionObjectNameArg(_T("Second Frame Name"), _T(""), _T("Frame 2"));
    NRKSdk.SetToleranceScalarOptionsArg(_T("Orientation Tolerance"), bUseHigh, highTol, bUseLow, lowTol);
    NRKSdk.SetToleranceVectorOptionsArg(_T("Position Tolerance"),
        bUseHighX, highTolX, bUseHighY, highTolY, bUseHighZ, highTolZ, bUseHighM, highTolM,
        bUseLowX, lowTolX, bUseLowY, lowTolY, bUseLowZ, lowTolZ, bUseLowM, lowTolM);
    NRKSdk.ExecuteStep();
}


void CSASDKMFCDlg::OnBnClickedButton9()
{
    NRKSdk.SetStep(_T("Construct Frame"));
    NRKSdk.SetCollectionObjectNameArg(_T("New Frame Name"), _T(""), _T("My Frame"));
    double T[4][4];
    T[0][0] = 0.987109; 	T[0][1] = -0.112363; 	T[0][2] = 0.113976; 	T[0][3] = 1.000000;
    T[1][0] = 0.121202; 	T[1][1] = 0.989879; 	T[1][2] = -0.073816; 	T[1][3] = 2.000000;
    T[2][0] = -0.104528; 	T[2][1] = 0.086678; 	T[2][2] = 0.990737; 	T[2][3] = 3.000000;
    T[3][0] = 0.000000; 	T[3][1] = 0.000000; 	T[3][2] = 0.000000; 	T[3][3] = 1.000000;
    SDKHelper helper(NRKSdk);
    helper.SetTransformArgHelper(_T("Transform in Working Coordinates"), T);
    NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Make Frame to Frame Relationship"));
    NRKSdk.SetCollectionObjectNameArg(_T("Relationship Name"), _T(""), _T("My Frame to World"));
    NRKSdk.SetCollectionObjectNameArg(_T("First Frame Name"), _T(""), _T("WORLD"));
    NRKSdk.SetCollectionObjectNameArg(_T("Second Frame Name"), _T(""), _T("My Frame"));
    NRKSdk.SetToleranceScalarOptionsArg(_T("Orientation Tolerance"), TRUE, 0.500000, TRUE, 0.500000);
    NRKSdk.SetToleranceVectorOptionsArg(_T("Position Tolerance"),
        TRUE, 2.000000, TRUE, 2.000000, TRUE, 2.000000, TRUE, 2.000000,
        TRUE, -2.000000, TRUE, -2.000000, TRUE, -2.000000, TRUE, -2.000000);
    NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Set Relationship Position Fit Constraints (Vector Type)"));
    NRKSdk.SetCollectionObjectNameArg(_T("Relationship Name"), _T(""), _T("My Frame to World"));
    NRKSdk.SetToleranceVectorOptionsArg(_T("Position Vector Constraint"),
        TRUE, 10.000000, TRUE, 10.000000, TRUE, 10.000000, FALSE, 10.000000,
        TRUE, -10.000000, TRUE, -10.000000, TRUE, -10.000000, FALSE, -10.000000);
    NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Set Relationship Orientation Fit Constraints (Vector Type)"));
    NRKSdk.SetCollectionObjectNameArg(_T("Relationship Name"), _T(""), _T("My Frame to World"));
    NRKSdk.SetToleranceVectorOptionsArg(_T("Orientation Vector Constraint"),
        TRUE, 15.000000, TRUE, 15.000000, TRUE, 15.000000, FALSE, 15.000000,
        TRUE, -15.000000, TRUE, -15.000000, TRUE, -15.000000, FALSE, -15.000000);
    NRKSdk.ExecuteStep();
}

//********************************************************************
// olga mantis #7823 - math functions
//********************************************************************
void CSASDKMFCDlg::OnBnClickedButton10()
{
    BOOL bSendStatus = FALSE;

    // angular units conversion
    NRKSdk.SetStep(_T("Double Angle Conversion"));

    CString angUnitsIN = _T("Degrees");
    CString angUnitsOUT = _T("Radians");
    double  valueIn = 1.0;
    double valueOUT = 0.0;

    // Available options: 
    // "Degrees", "Radians", "Milliradians", "Gons/Grad", "Mils", "Arcseconds" 
    NRKSdk.SetAngularUnitsArg(_T("Input Ang Units"), angUnitsIN);
    NRKSdk.SetDoubleArg(_T("Input Angle Double"), valueIn);

    // Available options: 
    // "Degrees", "Radians", "Milliradians", "Gons/Grad", "Mils", "Arcseconds" 
    NRKSdk.SetAngularUnitsArg(_T("Output Ang Units"), angUnitsOUT);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        if (NRKSdk.GetDoubleArg(_T("Output Angle Double"), &valueOUT))
        {
            CString msg;
            msg.Format(_T("%f (%s) = %f (%s)\n"), valueIn, angUnitsIN, valueOUT, angUnitsOUT);
            //          AfxMessageBox(msg);
            TRACE(msg);
        }
        else
            AfxMessageBox(_T("Subroutine call failed"));
    }
    //////////////////////////////////////////////////////////////////////////////////////////
    CString func = _T("sin(X)");
    valueOUT = 0.0;
    valueIn = 90.0;

    NRKSdk.SetStep(_T("Trig Function"));

    // Available options: 
    // "sin(X)", "cos(X)", "tan(X)", "asin(X)", "acos(X)", "atan(X)", "atan2(Y,X)", "Pi", 
    NRKSdk.SetTrigFunctionArg(_T("Function"), func);
    // Available options: 
    // "Degrees", "Deg:Min:Sec", "Radians", "Milliradians", "Gons/Grad", "Mils", "Arcseconds", "Deg:Min", 
    NRKSdk.SetAngularUnitsArg(_T("Angular Units"), angUnitsIN);
    NRKSdk.SetDoubleArg(_T("X Double In"), valueIn);
    NRKSdk.SetDoubleArg(_T("Y Double In"), 0.000000);

    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        if (NRKSdk.GetDoubleArg(_T("Double Result"), &valueOUT))
        {
            CString msg;
            msg.Format(_T("%s (%f %s) = %f\n"), func, valueIn, angUnitsIN, valueOUT);
            //          AfxMessageBox(msg);
            TRACE(msg);
        }
        else
            AfxMessageBox(_T("Subroutine call failed"));
    }

    //////////////////////////////////////////////////////////////////////////////////////////
    func = _T("log(X)");
    valueOUT = 0.0;
    valueIn = 100.0;

    NRKSdk.SetStep(_T("Logarithmic Function"));
    // Available options: 
    // "ln(X)", "log(X)", "e", 
    NRKSdk.SetLogarithmicFunctionArg(_T("Function"), func);
    NRKSdk.SetDoubleArg(_T("X Double In"), valueIn);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        if (NRKSdk.GetDoubleArg(_T("Double Result"), &valueOUT))
        {
            CString msg;
            msg.Format(_T("%s (%f) = %f\n"), func, valueIn, valueOUT);
            //          AfxMessageBox(msg);
            TRACE(msg);
        }
        else
            AfxMessageBox(_T("Subroutine call failed"));
    }
    ///////////////////////////////////////////////////////////////////////////////
    double A = 30.78;
    double B = 23.54;
    CString compSign = _T("<=");
    BOOL bValue;

    NRKSdk.SetStep(_T("Double Comparison (result)"));
    NRKSdk.SetDoubleArg(_T("Double A"), A);
    // Available options: 
    // "=", "<", ">", "<=", ">=", "!=", 
    NRKSdk.SetNumComparisonTypeArg(_T("Comparison Type"), compSign);
    NRKSdk.SetDoubleArg(_T("Double B"), B);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        if (NRKSdk.GetBoolArg(_T("Resultant Value"), &bValue))
        {
            CString msg;
            msg.Format(_T("%f%s%f? %s\n"), A, compSign, B, (bValue) ? _T("true") : _T("false"));
            AfxMessageBox(msg);
            TRACE(msg);
        }
        else
            AfxMessageBox(_T("Subroutine call failed"));
    }
    //////////////////////////////////////////////////////////////////////
    int C = 65;
    int D = 45;

    NRKSdk.SetStep(_T("Integer Comparison (result)"));
    NRKSdk.SetIntegerArg(_T("Integer A"), C);
    // Available options: 
    // "=", "<", ">", "<=", ">=", "!=", 
    NRKSdk.SetNumComparisonTypeArg(_T("Comparison Type"), compSign);
    NRKSdk.SetIntegerArg(_T("Integer B"), D);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        if (NRKSdk.GetBoolArg(_T("Resultant Value"), &bValue))
        {
            CString msg;
            msg.Format(_T("%d%s%d? %s\n"), C, compSign, D, (bValue) ? _T("true") : _T("false"));
            AfxMessageBox(msg);
            TRACE(msg);
        }
        else
            AfxMessageBox(_T("Subroutine call failed"));
    }
    //////////////////////////////////////////////////////////////////
    NRKSdk.SetStep(_T("Integer Math Operation"));
    NRKSdk.SetIntegerArg(_T("First Value"), C);
    // Available options: 
    // "+", "-", "*", "/", "%", 
    CString mathSign = _T("+");
    NRKSdk.SetMathOperationArg(_T("Operation"), mathSign);
    NRKSdk.SetIntegerArg(_T("Second Value"), D);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        long value;

        if (NRKSdk.GetIntegerArg(_T("Resultant Value"), &value))
        {
            CString msg;
            msg.Format(_T("Int: %d%s%d=%d\n"), C, mathSign, D, value);
            AfxMessageBox(msg);
            TRACE(msg);
        }
        else
            AfxMessageBox(_T("Subroutine call failed"));
    }
    ////////////////////////////////////////////////////////////////
    NRKSdk.SetStep(_T("Double Math Operation"));
    NRKSdk.SetDoubleArg(_T("First Value"), A);
    // Available options: 
    // "+", "-", "*", "/", "%", 
    NRKSdk.SetMathOperationArg(_T("Operation"), mathSign);
    NRKSdk.SetDoubleArg(_T("Second Value"), B);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        double value;

        if (NRKSdk.GetDoubleArg(_T("Resultant Value"), &value))
        {
            CString msg;
            msg.Format(_T("Double: %f%s%f=%f\n"), A, mathSign, B, value);
            AfxMessageBox(msg);
            TRACE(msg);
        }
        else
            AfxMessageBox(_T("Subroutine call failed"));
    }

}

//******************************************************************************************************
// olga XIT-311: 
// Analysis Operations...>> Relationship Operations >> "Move Collections by Minimizing Relationships"
//******************************************************************************************************
void CSASDKMFCDlg::OnBnClickedButton11()
{
    BOOL bSendStatus = FALSE;

    NRKSdk.SetStep(_T("Move Collections by Minimizing Relationships"));

    CStringArray stringList;
    stringList.Add(_T("B"));
    SDKHelper helper(NRKSdk);
    helper.SetStringRefListArgHelper(_T("Collections To Move"), stringList);

    CStringArray objNameList;
    objNameList.Add(_T("A::Canopy::Relationship"));
    objNameList.Add(_T("A::Sides::Relationship"));
    objNameList.Add(_T("A::Top::Relationship"));
    objNameList.Add(_T("A::Tabletop::Relationship"));
    objNameList.Add(_T("A::Centerline::Relationship"));
    helper.SetCollectionObjectNameRefListArgHelper(_T("Relationships To Minimize"), objNameList);

    NRKSdk.SetBoolArg(_T("Perform 'Direct' Search"), FALSE);
    NRKSdk.SetFitDofOptionsArg(_T("Motion to allow"), TRUE, TRUE, TRUE, TRUE, TRUE, TRUE, TRUE);
    NRKSdk.SetBoolArg(_T("Use Fit Dialog"), FALSE);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == SdkError)
        {
            CStringArray msgs;
            // Something went wrong... check for any messages provided...
            SDKHelper	helper(NRKSdk);
            if (helper.GetMPStepMessagesHelper(msgs))
            {
                CString singleLine;
                for (int i = 0; i < msgs.GetSize(); i++)
                {
                    singleLine += msgs[i];
                    singleLine += _T("\r\n");
                }
                AfxMessageBox(singleLine);
            }
        }
    }
}

//******************************************************************************************************
// olga XIT-659: 
// Analysis Operations...>> "Query Points To Objects"
// Checked case when collection has multiple objects with duplicated names
// 
// Used for testing: Samples/Query Points to Surfaces modified sample file. 
//******************************************************************************************************
void CSASDKMFCDlg::OnBnClickedButton12()
{
    BOOL bSendStatus = FALSE;

    // olga XIT-619 start - Wildcard Select in MP is not working correctly
    //NRKSdk.SetStep(_T("Set Wild Card Asterisk Mode"));
    //NRKSdk.SetBoolArg(_T("Auto Wrap Search String?"), FALSE);
    //bSendStatus = NRKSdk.ExecuteStep();

    ////make objects list by wild card
    //NRKSdk.SetStep(_T("Make a Collection Object Name Reference List- WildCard Selection"));
    //NRKSdk.SetStringArg(_T("Collection Wildcard Criteria"), _T("A"));
    //NRKSdk.SetStringArg(_T("Object Wildcard Criteria"), _T("*"));
    //NRKSdk.SetObjectTypeArg(_T("Object Type"), _T("Any"));
    //bSendStatus = NRKSdk.ExecuteStep();

    ////get the list
    //    CStringArray objNameList;
    //SDKHelper helper(NRKSdk);
    //helper.GetCollectionObjectNameRefListArgHelper(_T("Resultant Collection Object Name Reference List"), objNameList);  


    // olga XIT-619 end


    //NRKSdk.SetStep(_T("Set Relationship Voxel Cloud Display"));
    //NRKSdk.SetCollectionObjectNameArg(_T("Relationship Name"), _T(""), _T("p1"));
    //NRKSdk.SetBoolArg(_T("Enable Voxel Cloud Display?"), TRUE);
    //NRKSdk.SetDoubleArg(_T("Voxel Size (-1.0 autodetect)"), -1.000000);
    //NRKSdk.SetIntegerArg(_T("Min Pts Count Per Voxel"), 3);
    //NRKSdk.SetDoubleArg(_T("Voxel Rendering Diameter % (-1.0 fast)"), 125.000000);
    //NRKSdk.SetSurfaceAnalysisModeArg(_T("Surface Analysis Mode"), _T("Relationship"));
    //NRKSdk.SetColorizationOptionsArg(_T("Colorization Options"),_T("Continuous"),_T("Blue"),_T("Green"),_T("Red"), FALSE, TRUE, FALSE, 100.000000, 1, FALSE, 0.100000, FALSE, FALSE, TRUE, FALSE, 0.000000, 0.000000, 0.030000, 0.000000);
    //NRKSdk.SetBoolArg(_T("Show Color Bar in View?"), TRUE);
    //bSendStatus = NRKSdk.ExecuteStep();



    // olga XIT-659 - make objects list
    NRKSdk.SetStep(_T("Make a Collection Object Name Ref List - By Type"));
    NRKSdk.SetStringArg(_T("Collection"), _T(""));
    NRKSdk.SetObjectTypeArg(_T("Object Type"), _T("Surface"));
    bSendStatus = NRKSdk.ExecuteStep();

    // get the list
    CStringArray objNameList;
    SDKHelper helper(NRKSdk);
    helper.GetCollectionObjectNameRefListArgHelper(_T("Resultant Collection Object Name List"), objNameList);

    CString singleLine;
    singleLine.Format(_T("List has %d items\r\n"), objNameList.GetSize());

    for (int i = 0; i < objNameList.GetSize(); i++)
    {
        singleLine += objNameList[i];
        singleLine += _T("\r\n");
    }
    AfxMessageBox(singleLine);


    // make groups list
    NRKSdk.SetStep(_T("Make a Collection Object Name Ref List - By Type"));
    NRKSdk.SetStringArg(_T("Collection"), _T(""));
    NRKSdk.SetObjectTypeArg(_T("Object Type"), _T("Point Group"));
    bSendStatus = NRKSdk.ExecuteStep();

    // get point group list
    CStringArray ptNameList;
    helper.GetCollectionObjectNameRefListArgHelper(_T("Resultant Collection Object Name List"), ptNameList);

    singleLine = _T("");
    for (int i = 0; i < ptNameList.GetSize(); i++)
    {
        singleLine += ptNameList[i];
        singleLine += _T("\r\n");
    }
    AfxMessageBox(singleLine);


    // query points to objects
    //NRKSdk.SetStep(_T("Query Points to Objects"));
    // prepare point list
    //CStringArray ptNameList;
    //ptNameList.Add(_T("A::Control::1"));
    //ptNameList.Add(_T("A::Control::2"));
    //ptNameList.Add(_T("A::Control::3"));
    //ptNameList.Add(_T("A::Control::4"));
    //    helper.SetPointNameRefListArgHelper(_T("Point Names"), ptNameList);

    NRKSdk.SetStep(_T("Query Groups to Objects"));
    helper.SetPointNameRefListArgHelper(_T("Group Name List (Groups to Project)"), ptNameList);
    helper.SetCollectionObjectNameRefListArgHelper(_T("Object Name List (Objects to Project to)"), objNameList);
    NRKSdk.SetCollectionObjectNameArg(_T("Resulting Object Name"), _T(""), _T("myvec"));
    NRKSdk.SetProjectionOptionsArg(_T("Projection Options"), _T("Object To Probe Vectors"), FALSE, FALSE, 0.000000, FALSE, 0.000000);
    NRKSdk.SetDoubleArg(_T("RMS Tolerance (0.0 for none)"), 0.000000);
    NRKSdk.SetDoubleArg(_T("Maximum Absolute Tolerance (0.0 for none)"), 0.000000);
    NRKSdk.SetBoolArg(_T("Show Results Dialog?"), FALSE);


    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == SdkError)
        {
            CStringArray msgs;
            // Something went wrong... check for any messages provided...
            SDKHelper	helper(NRKSdk);
            if (helper.GetMPStepMessagesHelper(msgs))
            {
                CString singleLine;
                for (int i = 0; i < msgs.GetSize(); i++)
                {
                    singleLine += msgs[i];
                    singleLine += _T("\r\n");
                }
                AfxMessageBox(singleLine);
            }
        }
    }

    DOUBLE rms = 0.0, absdev = 0.0, avgdev = 0.0, stddev = 0.0;
    NRKSdk.GetDoubleArg(_T("RMS Deviation"), &rms);
    NRKSdk.GetDoubleArg(_T("Max Absolute Deviation"), &absdev);
    NRKSdk.GetDoubleArg(_T("Average Deviation"), &avgdev);
    NRKSdk.GetDoubleArg(_T("Standard Deviation"), &stddev);

    singleLine.Format(_T("RMS: %f\nMax Absolute Deviation: %f\nAverage Deviation: :%f\nStandard Deviation: %f"),
        rms, absdev, avgdev, stddev);
    AfxMessageBox(singleLine);
}
//******************************************************************************************************
// olga XIT-719: transition to new SA Colorizer
// "Set Vector Group Colorization Options (All)"
//******************************************************************************************************
void CSASDKMFCDlg::OnBnClickedButton13()
{
    BOOL bSendStatus = FALSE;

    // olga XIT-917 - SA SDK SetColorizationOptionsArg fields:
    //   
    //    0.		LPCTSTR colorRangeMethod, 
    //    1.		LPCTSTR baseHighColor, 
    //    2.		LPCTSTR baseMidColor, 
    //    3.		LPCTSTR baseLowColor, 
    //    4.		VARIANT_BOOL bDrawTubes, 
    //    5.		VARIANT_BOOL bDrawArrowheads, 
    //    6.		VARIANT_BOOL bIndicateValues, 

    //    7.		DOUBLE vectorMagnification, 
    //    8.		LONG vectorWidth, 
    //    9.		VARIANT_BOOL bDrawBlotches, 
    //    10.		DOUBLE blotchSize, 
    //    11.		VARIANT_BOOL bShowOutOfToleranceOnly, 
    //    12.		VARIANT_BOOL bShowColorBarInView, 

    //    13.		VARIANT_BOOL bShowColorBarPercentages, 
    //    14.		VARIANT_BOOL bShowColorBarFractions, 

    //    15.		DOUBLE highSaturationLimit, 
    //    16.		DOUBLE lowSaturationLimit, 
    //    17.		DOUBLE highTolerance, 
    //    18.		DOUBLE lowTolerance

    // style name
    CString colorRangeMethod = _T("Discrete Colors");
    // base colors
    CString baseHighColor = _T("Blue");
    CString baseMidColor = _T("Green");
    CString baseLowColor = _T("Red");

    double highSaturationLimit = 100.00;
    double lowSaturationLimit = -5;
    double highTolerance = 0.5;
    double lowTolerance = -0.5;

    NRKSdk.SetStep(_T("Set Vector Group Colorization Options (All)"));
    NRKSdk.SetColorizationOptionsArg(_T("Colorization Options"),
        colorRangeMethod,
        baseHighColor, baseMidColor, baseLowColor,
        FALSE,           // tubes
        FALSE,          // Draw Arrow heads
        FALSE,          // Indicate Values
        5.0,           // vector magnification - 
        1,              // vector width
        TRUE,          // Draw Blotches
        5,              // blotch size - if it is too small, the tubes are invisible
        FALSE,          // color bar - out of tolerance
        TRUE,           // color bar - show
        TRUE,           // color bar - %
        TRUE,           // color bar - fractions
        highSaturationLimit, lowSaturationLimit,
        highTolerance, lowTolerance);
    NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == SdkError)
        {
            CStringArray msgs;
            // Something went wrong... check for any messages provided...
            SDKHelper	helper(NRKSdk);
            if (helper.GetMPStepMessagesHelper(msgs))
            {
                CString singleLine;
                for (int i = 0; i < msgs.GetSize(); i++)
                {
                    singleLine += msgs[i];
                    singleLine += _T("\r\n");
                }
                AfxMessageBox(singleLine);
            }
        }
    }
}

//*************************************************************************
// olga XIT-1135 - Test for Set/Get multi-line notes (EditText MP Argument)
// For example, Set/Get Object Notes
//*************************************************************************
void CSASDKMFCDlg::OnBnClickedButton14()
{
    BOOL bSendStatus = FALSE;

    // olga XIT-1135 - first create notes
    CStringArray myNotes;
    myNotes.Add(_T("Line 1"));
    myNotes.Add(_T("Line 2"));
    myNotes.Add(_T("Line 3"));
    myNotes.Add(_T("Line 4"));

    SDKHelper helper(NRKSdk);
    // prepare a Set command
    NRKSdk.SetStep(_T("Set Object Notes"));
    NRKSdk.SetCollectionObjectNameArg(_T("Object"), _T("A"), _T("World"));
    helper.SetEditTextArgHelper(_T("Notes"), myNotes);
    bSendStatus = NRKSdk.ExecuteStep();

    // check that we succeeded - Get notes
    CStringArray objNotes;
    NRKSdk.SetStep(_T("Get Object Notes"));
    NRKSdk.SetCollectionObjectNameArg(_T("Object"), _T("A"), _T("World"));
    helper.GetEditTextArgHelper(_T("Notes"), objNotes);
    bSendStatus = NRKSdk.ExecuteStep();

    for (int i = 0; i < objNotes.GetSize(); i++)
        TRACE(_T("%s \n"), objNotes.GetAt(i));

    // show to user - results
    NRKSdk.SetStep(_T("Notify User Text Array"));
    helper.SetStringRefListArgHelper(_T("Notification Text"), objNotes);
    NRKSdk.SetFontTypeArg(_T("Font"), _T("MS Shell Dlg"), 8, 0, 0, 0);
    NRKSdk.SetBoolArg(_T("Auto expand to fit text?"), FALSE);
    bSendStatus = NRKSdk.ExecuteStep();
}
//*************************************************************************************
// olga 2018.09.24 XIT-1214
// * Construction Operations >> Make a Collection Object Name Reference List- Runtime Select
// * Construction Operations >> Construct Surfaces by Dissecting Surfaces from Ref List
// * Construction Operations >> Construct Points From Surfaces On UV Grid
//**************************************************************************************
void CSASDKMFCDlg::OnBnClickedButton16()
{
    BOOL bSendStatus = FALSE;

    // first - select surfaces
    NRKSdk.SetStep(_T("Make a Collection Object Name Reference List- Runtime Select"));
    NRKSdk.SetStringArg(_T("User Prompt"), _T("select surfaces"));
    NRKSdk.SetObjectTypeArg(_T("Object Type"), _T("Surface"));
    bSendStatus = NRKSdk.ExecuteStep();

    SDKHelper helper(NRKSdk);
    CStringArray surfaceNameList;
    helper.GetCollectionObjectNameRefListArgHelper(_T("Resultant Collection Object Name Reference List"), surfaceNameList);

    // disssect selected surfaces
    NRKSdk.SetStep(_T("Construct Surfaces by Dissecting Surfaces from Ref List"));
    helper.SetCollectionObjectNameRefListArgHelper(_T("Surfaces to Dissect"), surfaceNameList);
    bSendStatus = NRKSdk.ExecuteStep();

    CStringArray facesList;
    helper.GetCollectionObjectNameRefListArgHelper(_T("Resultant Surfaces List"), facesList);

    NRKSdk.SetStep(_T("Construct Points From Surfaces On UV Grid"));
    helper.SetCollectionObjectNameRefListArgHelper(_T("Surface List"), facesList);
    NRKSdk.SetStringArg(_T("UV Point Group Base Name"), _T("UV Points"));
    NRKSdk.SetBoolArg(_T("Make Each Line Separate Group?"), FALSE);
    NRKSdk.SetIntegerArg(_T("Number of U Grids"), 5);
    NRKSdk.SetIntegerArg(_T("Number of V Grids"), 5);
    // Available options: 
    // "Include Edges", "Exclude Edges", "Edges Only", 
    NRKSdk.SetEdgeModeArg(_T("Edge Point Mode"), _T("Include Edges"));
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == SdkError)
        {
            CStringArray msgs;
            // Something went wrong... check for any messages provided...
            SDKHelper	helper(NRKSdk);
            if (helper.GetMPStepMessagesHelper(msgs))
            {
                CString singleLine;
                for (int i = 0; i < msgs.GetSize(); i++)
                {
                    singleLine += msgs[i];
                    singleLine += _T("\r\n");
                }
                AfxMessageBox(singleLine);
            }
        }
    }
}

//*********************************************************************************************************************
// olga 2018.09.24 XIT-1024 - Added 7 arguments to SA SDK to support all types of "Make <geometry> Fit Profile" commands:
// 1. MPDegreeOfFreedomArguement 
// 2. MPFitMethodArguement 
// 3. MPSlotTypeArguement 
// 4. MPCompTechniqueArguement 
// 5. MPNormalDirectionArguement 
// 6. MPMeasuredSideForRadialOffsetArguement 
//*********************************************************************************************************************
void CSASDKMFCDlg::OnBnClickedButton17()
{
    BOOL bSendStatus = FALSE;

    NRKSdk.SetStep(_T("Make Line Fit Profile"));
    NRKSdk.SetStringArg(_T("Fit Profile Name"), _T("myLine"));
    NRKSdk.SetBoolArg(_T("Reverse Normal Vector after fit?"), FALSE);
    NRKSdk.SetBoolArg(_T("Make Cardinal Points?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.1: Point A?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.2: Point B?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.3: Mid Point?"), TRUE);
    bSendStatus = NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Make Plane Fit Profile"));
    NRKSdk.SetStringArg(_T("Fit Profile Name"), _T("myPlane"));
    NRKSdk.SetMeasuredSideForPlanarOffsetArg(_T("Measured Side for Planar Offset"), _T("Above Plane"));
    NRKSdk.SetDoubleArg(_T("Override Planar Offset (-1.0 use current)"), -1.000000);
    NRKSdk.SetNormalDirectionArg(_T("Planar Offset Direction"), _T("Probing Direction"));
    NRKSdk.SetBoolArg(_T("Reverse Normal Vector after fit?"), FALSE);
    NRKSdk.SetBoolArg(_T("Make Cardinal Points?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.1: Centroid?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.2: Point on Normal?"), TRUE);
    bSendStatus = NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Make Circle Fit Profile"));
    NRKSdk.SetStringArg(_T("Fit Profile Name"), _T("myCircle"));
    NRKSdk.SetMeasuredSideForRadialOffsetArg(_T("Measured Side for Radial Offset"), _T("Outside"));
    NRKSdk.SetDoubleArg(_T("Override Radial Offset (-1.0 use current)"), -1.000000);
    NRKSdk.SetMeasuredSideForPlanarOffsetArg(_T("Measured Side for Planar Offset"), _T("Above Plane"));
    NRKSdk.SetDoubleArg(_T("Override Planar Offset (-1.0 use current)"), -1.000000);
    NRKSdk.SetNormalDirectionArg(_T("Planar Offset Direction"), _T("Probing Direction"));
    NRKSdk.SetDoubleArg(_T("Lock Radius (-1.0 do not lock)"), -1.000000);
    NRKSdk.SetCompTechniqueArg(_T("Circle Computation Technique"), _T("Standard"));
    NRKSdk.SetBoolArg(_T("Reverse Normal Vector after fit?"), FALSE);
    NRKSdk.SetBoolArg(_T("Make Cardinal Points?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.1: Center?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.2: Point on Normal?"), TRUE);
    bSendStatus = NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Make Slot Fit Profile"));
    NRKSdk.SetStringArg(_T("Fit Profile Name"), _T("mySlot"));
    NRKSdk.SetMeasuredSideForRadialOffsetArg(_T("Measured Side for Radial Offset"), _T("Outside"));
    NRKSdk.SetDoubleArg(_T("Override Radial Offset (-1.0 use current)"), -1.000000);
    NRKSdk.SetMeasuredSideForPlanarOffsetArg(_T("Measured Side for Planar Offset"), _T("Above Plane"));
    NRKSdk.SetDoubleArg(_T("Override Planar Offset (-1.0 use current)"), -1.000000);
    NRKSdk.SetNormalDirectionArg(_T("Planar Offset Direction"), _T("Probing Direction"));
    NRKSdk.SetSlotTypeArg(_T("Slot Type"), _T("Round"));
    NRKSdk.SetCompTechniqueArg(_T("Slot Computation Technique"), _T("Standard"));
    NRKSdk.SetBoolArg(_T("Reverse Normal Vector after fit?"), FALSE);
    NRKSdk.SetBoolArg(_T("Make Cardinal Points?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.1: Center?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.2: Point on Normal?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.3: Centerline Pt.1?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.4: Centerline Pt.2?"), TRUE);
    bSendStatus = NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Make Ellipse Fit Profile"));
    NRKSdk.SetStringArg(_T("Fit Profile Name"), _T("myEllipse"));
    NRKSdk.SetMeasuredSideForRadialOffsetArg(_T("Measured Side for Radial Offset"), _T("Outside"));
    NRKSdk.SetDoubleArg(_T("Override Radial Offset (-1.0 use current)"), -1.000000);
    NRKSdk.SetMeasuredSideForPlanarOffsetArg(_T("Measured Side for Planar Offset"), _T("Above Plane"));
    NRKSdk.SetDoubleArg(_T("Override Planar Offset (-1.0 use current)"), -1.000000);
    NRKSdk.SetNormalDirectionArg(_T("Planar Offset Direction"), _T("Probing Direction"));
    NRKSdk.SetBoolArg(_T("Reverse Normal Vector after fit?"), FALSE);
    NRKSdk.SetBoolArg(_T("Make Cardinal Points?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.1: Center?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.2: Point on Normal?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.3: Focal Pt.1?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.4: Focal Pt.2?"), TRUE);
    bSendStatus = NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Make Sphere Fit Profile"));
    NRKSdk.SetStringArg(_T("Fit Profile Name"), _T("mySphere"));
    NRKSdk.SetMeasuredSideForRadialOffsetArg(_T("Measured Side for Radial Offset"), _T("Outside"));
    NRKSdk.SetDoubleArg(_T("Override Radial Offset (-1.0 use current)"), -1.000000);
    NRKSdk.SetDoubleArg(_T("Lock Radius (-1.0 do not lock)"), -1.000000);
    NRKSdk.SetBoolArg(_T("Make Cardinal Points?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.1: Center?"), TRUE);
    bSendStatus = NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Make Cone Fit Profile"));
    NRKSdk.SetStringArg(_T("Fit Profile Name"), _T("myCone"));
    NRKSdk.SetMeasuredSideForRadialOffsetArg(_T("Measured Side for Radial Offset"), _T("Outside"));
    NRKSdk.SetDoubleArg(_T("Override Radial Offset (-1.0 use current)"), -1.000000);
    NRKSdk.SetDoubleArg(_T("Lock Angle in degrees (-1.0 do not lock)"), -1.000000);
    NRKSdk.SetBoolArg(_T("Make Cardinal Points?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.1: Vertex?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.2: Point on Axis?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.3: Cut Point on Axis?"), TRUE);
    bSendStatus = NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Make Paraboloid Fit Profile"));
    NRKSdk.SetStringArg(_T("Fit Profile Name"), _T("myParaboloid"));
    NRKSdk.SetMeasuredSideForRadialOffsetArg(_T("Measured Side for Radial Offset"), _T("Outside"));
    NRKSdk.SetDoubleArg(_T("Override Radial Offset (-1.0 use current)"), -1.000000);
    NRKSdk.SetDoubleArg(_T("Lock Focal Length (-1.0 do not lock)"), -1.000000);
    NRKSdk.SetDegreeOfFreedomArg(_T("Degree of Freedom"), _T("Any"));
    NRKSdk.SetBoolArg(_T("Make Cardinal Points?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.1: Vertex?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.2: Focal Point?"), TRUE);
    bSendStatus = NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Make Cylinder Fit Profile"));
    NRKSdk.SetStringArg(_T("Fit Profile Name"), _T("myCylinder"));
    NRKSdk.SetMeasuredSideForRadialOffsetArg(_T("Measured Side for Radial Offset"), _T("Outside"));
    NRKSdk.SetDoubleArg(_T("Override Radial Offset (-1.0 use current)"), -1.000000);
    NRKSdk.SetDoubleArg(_T("Lock Radius (-1.0 do not lock)"), -1.000000);
    NRKSdk.SetFitMethodArg(_T("Locked Radius Fit Method"), _T("Minimum RMS"));
    NRKSdk.SetCompTechniqueArg(_T("Cylinder Computation Technique"), _T("Standard"));
    NRKSdk.SetBoolArg(_T("Make Cardinal Points?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.1: Begin Pt?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.2: End Pt?"), TRUE);
    NRKSdk.SetBoolArg(_T("Cardinal Pt.3: Center?"), TRUE);
    bSendStatus = NRKSdk.ExecuteStep();


}

//*************************************************************************************
// olga 2018.09.24 XIT-1213 - verified Picture related commands
// - "Make a Picture Name Ref List"
// - "Add Pictures to Report Bar"
// - "Rename Picture"
// - "Set Scale for Picture"
// - "Delete Picture"
//*************************************************************************************
void CSASDKMFCDlg::OnBnClickedButton18()
{
    SDKHelper helper(NRKSdk);
    BOOL bSendStatus = FALSE;

    //  make empty list
    NRKSdk.SetStep(_T("Make a Picture Name Ref List"));
    bSendStatus = NRKSdk.ExecuteStep();

    CStringArray picNameList;

    // add a picture to the list
    picNameList.Add(_T("A::Photo::Picture"));
    picNameList.Add(_T("A::Photo1::Picture"));

    // show in Report Bar
    NRKSdk.SetStep(_T("Add Pictures to Report Bar"));
    helper.SetCollectionObjectNameRefListArgHelper(_T("Picture(s)"), picNameList);
    CString singleLine;
    singleLine.Format(_T("List has %d items\r\n"), picNameList.GetSize());

    for (int i = 0; i < picNameList.GetSize(); i++)
    {
        singleLine += picNameList[i];
        singleLine += _T("\r\n");
    }
    AfxMessageBox(singleLine);
    NRKSdk.SetBoolArg(_T("Clear Existing?"), FALSE);
    bSendStatus = NRKSdk.ExecuteStep();

    // rename picture
    NRKSdk.SetStep(_T("Rename Picture"));
    NRKSdk.SetCollectionObjectNameArg(_T("Original Picture Name"), _T(""), _T("Photo"));
    NRKSdk.SetCollectionObjectNameArg(_T("New Picture Name"), _T(""), _T("myPhoto"));
    NRKSdk.SetBoolArg(_T("Overwrite if exists?"), FALSE);
    bSendStatus = NRKSdk.ExecuteStep();

    // scale picture
    NRKSdk.SetStep(_T("Set Scale for Picture"));
    NRKSdk.SetCollectionObjectNameArg(_T("Picture Name"), _T(""), _T("myPhoto"));
    NRKSdk.SetDoubleArg(_T("Scale"), 200.000000);
    bSendStatus = NRKSdk.ExecuteStep();

    // delete picture
    NRKSdk.SetStep(_T("Delete Picture"));
    NRKSdk.SetCollectionObjectNameArg(_T("Picture Name"), _T(""), _T("Photo2"));
    bSendStatus = NRKSdk.ExecuteStep();

    /////////////////////////////////////////////////////////////
    //
    // olga XIT-1217 - set rendering mode
    //********************************************
    NRKSdk.SetStep(_T("Set Object(s) Translucency"));
    CStringArray objNameList;
    objNameList.Add(_T("A::Sphere::Sphere"));

    helper.SetCollectionObjectNameRefListArgHelper(_T("Objects to change"), objNameList);
    // Available options: 
    // "Solid", "Translucent", "Wireframe", 
    NRKSdk.SetTranslucencyTypeArg(_T("Rendering Type"), _T("Solid"));
    NRKSdk.SetDoubleArg(_T("Opacity Value"), 0.000000);
    bSendStatus = NRKSdk.ExecuteStep();


}

//******************************************************
// olga XIT-1380 - Instrument Operational Check
// olga XIT-584 - Set/Get Active Units
//******************************************************
void CSASDKMFCDlg::OnBnClickedButton19()
{
    SDKHelper helper(NRKSdk);
    BOOL bSendStatus = FALSE;

    // olga XIT-1380 - Instrument Operational Check
    //NRKSdk.SetStep(_T("Instrument Operational Check"));
    //NRKSdk.SetColInstIdArg(_T("Instrument to Check"), _T("A"), 0);
    //NRKSdk.SetStringArg(_T("Check Type"), _T("Valid Distance"));
    //bSendStatus = NRKSdk.ExecuteStep();

    //if (bSendStatus)
    //{
    //    LONG rCode;
    //    NRKSdk.GetMPStepResult(&rCode);
    //    if (rCode == DoneSuccess)
    //    {
    //        TRACE(_T("The check was performed successfully\n"));
    //    }
    //    else
    //         TRACE(_T("The check was not successful\n"));
    //}

    // olga XIT-584 - Set/Get Active Units
    NRKSdk.SetStep(_T("Set Active Units"));
    // Available options: 
    // "Meters", "Centimeters", "Millimeters", "Feet", "Inches", 
    NRKSdk.SetDistanceUnitsArg(_T("Length"), _T("Inches"));
    NRKSdk.SetBoolArg(_T("Display Inch Fractions?"), FALSE);
    NRKSdk.SetDoubleArg(_T("Inch Fraction Denominator?"), 16.000000);
    NRKSdk.SetBoolArg(_T("Simplify Inch Fraction?"), TRUE);
    // Available options: 
    // "Fahrenheit", "Celsius", 
    NRKSdk.SetTemperatureUnitsArg(_T("Temperature"), _T("Fahrenheit"));
    // Available options: 
    // "Degrees", "Deg:Min:Sec", "Radians", "Milliradians", 
    // "Gons/Grad", "Mils", "Arcseconds", "Deg:Min", 
    NRKSdk.SetAngularUnitsArg(_T("Angular"), _T("Degrees"));
    bSendStatus = NRKSdk.ExecuteStep();
    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            TRACE(_T("Set Active Units success\n"));
        }
        else
            TRACE(_T("Set Active Units failure\n"));
    }

    // get them back
    NRKSdk.SetStep(_T("Get Active Units"));
    bSendStatus = NRKSdk.ExecuteStep();
    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);

        if (rCode == DoneSuccess)
        {
            // Now get the answer
            CString strUnit;
            CComBSTR bstrUnit;
            if (NRKSdk.GetStringArg(_T("Length"), &bstrUnit))
            {
                strUnit = bstrUnit;
                CString msg;
                msg.Format(_T("Length unit: %s"), strUnit);
                AfxMessageBox(msg);
            }
            // Must release the BSTR returned.
            bstrUnit.Empty();

            if (NRKSdk.GetStringArg(_T("Angular"), &bstrUnit))
            {
                strUnit = bstrUnit;
                CString msg;
                msg.Format(_T("Angular unit: %s"), strUnit);
                AfxMessageBox(msg);
            }
            // Must release the BSTR returned.
            bstrUnit.Empty();

            if (NRKSdk.GetStringArg(_T("Temperature"), &bstrUnit))
            {
                strUnit = bstrUnit;
                CString msg;
                msg.Format(_T("Temperature unit: %s"), strUnit);
                AfxMessageBox(msg);
            }
            // Must release the BSTR returned.
            bstrUnit.Empty();
        }
    }
}

//*****************************************************************
// olga 2019.07.18 XIT-586 - UDP Settings in Watch Window Template
// Test it with already running Faro Vantage
//*****************************************************************
void CSASDKMFCDlg::OnBnClickedButton20()
{
    SDKHelper helper(NRKSdk);
    BOOL bSendStatus = FALSE;

    // set watch window template
    NRKSdk.SetStep(_T("Watch Window Template 3D"));

    NRKSdk.SetCollectionObjectNameArg(_T("Watch Window Template Name"), _T(""), _T("New")); // A0

    // precision
    NRKSdk.SetIntegerArg(_T("Linear Precision"), 4);
    NRKSdk.SetIntegerArg(_T("Angular Precision"), 3);

    // font
    NRKSdk.SetFontTypeArg(_T("Font"), _T("MS Shell Dlg"), 8, 0, 0, 0);
    NRKSdk.SetColorArg(_T("Text Color"), 0, 0, 255);
    NRKSdk.SetColorArg(_T("Background Color"), 255, 255, 255);
    NRKSdk.SetColorArg(_T("Highlight Color"), 255, 0, 0);

    // deviation
    NRKSdk.SetBoolArg(_T("Show Deviation 1?"), TRUE);
    NRKSdk.SetBoolArg(_T("Show Deviation 2?"), TRUE);
    NRKSdk.SetBoolArg(_T("Show Deviation 3?"), TRUE);
    NRKSdk.SetBoolArg(_T("Show Deviation Mag?"), TRUE);

    // coordinate system
    NRKSdk.SetCoordinateSystemTypeArg(_T("Coordinate System"), _T("Cartesian"));

    // UDP
    NRKSdk.SetUdpTransmitSettingsArg(_T("UDP Network Transmit Settings"), TRUE, TRUE, _T(""), 10000);

    // frame
    NRKSdk.SetBoolArg(_T("Report In Working Frame?"), TRUE);
    NRKSdk.SetCollectionObjectNameArg(_T("Reference Frame"), _T(""), _T(""));

    // tolerance
    NRKSdk.SetToleranceVectorOptionsArg(_T("Default Tolerance (Closest Point & Point to Point)"),
        FALSE, 0.000000, FALSE, 0.000000, FALSE, 0.000000, FALSE, 0.000000,
        FALSE, 0.000000, FALSE, 0.000000, FALSE, 0.000000, FALSE, 0.000000);
    NRKSdk.SetDoubleArg(_T("Default Tolerance (Point to Objects)"), 0.000000);

    // misc
    NRKSdk.SetBoolArg(_T("Transparent Background?"), FALSE);
    NRKSdk.SetBoolArg(_T("Hide Units?"), FALSE);
    NRKSdk.SetBoolArg(_T("Show Graphical Guide?"), FALSE);

    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            TRACE(_T("The operation was performed successfully\n"));
        }
        else
            TRACE(_T("The operation was not successful\n"));
    }

    // Construct a Point in Working Coordinates
    NRKSdk.SetStep(_T("Construct a Point in Working Coordinates"));
    NRKSdk.SetPointNameArg(_T("Point Name"), _T(""), _T("New"), _T("Point To Watch"));
    NRKSdk.SetVectorArg(_T("Working Coordinates"), 0.000000, 0.000000, 0.000000);
    bSendStatus = NRKSdk.ExecuteStep();

    // watch point to point in template based window
    NRKSdk.SetStep(_T("Watch Point To Point"));
    NRKSdk.SetColInstIdArg(_T("Instrument's ID"), _T(""), 0);
    NRKSdk.SetPointNameArg(_T("Reference Point"), _T(""), _T("New"), _T("Point To Watch"));
    NRKSdk.SetCollectionObjectNameArg(_T("3 DOF Watch Window Properties"), _T(""), _T("New"));
    NRKSdk.SetStringArg(_T("Measurement Mode"), _T(""));
    NRKSdk.SetBoolArg(_T("Pause MP Until Closed"), FALSE);
    NRKSdk.SetIntegerArg(_T("Window Top Left X Position"), 0);
    NRKSdk.SetIntegerArg(_T("Window Top Left Y Position"), 0);
    NRKSdk.SetIntegerArg(_T("Window Width"), 0);
    NRKSdk.SetIntegerArg(_T("Window Height"), 0);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            TRACE(_T("The operation was performed successfully\n"));
        }
        else
            TRACE(_T("The operation was not successful\n"));
    }


}

//************************************************************
// olga 2020.10.22 XIT-2275 - Export ASCII Frame
// Export Frames Tested with the file attached to JIRA XIT-2275
// Export ASCII Points is tested with Random group of 100 points
//
// olga 2022.03.02 XIT-2824 - "Import ASCII: Predefined Formats"
// - "Direct CAD Access"
//***********************************************************
void CSASDKMFCDlg::OnBnClickedButton21()
{
    BOOL bSendStatus = FALSE;

    // olga XIT-2275 - make objects list
    //NRKSdk.SetStep(_T("Make a Collection Object Name Ref List - By Type"));
    //NRKSdk.SetStringArg(_T("Collection"), _T("B"));
    //NRKSdk.SetObjectTypeArg(_T("Object Type"), _T("Frame"));
    //bSendStatus = NRKSdk.ExecuteStep( );

    //// get the list
    //CStringArray objNameList;
    SDKHelper helper(NRKSdk);
    //helper.GetCollectionObjectNameRefListArgHelper(_T("Resultant Collection Object Name List"), objNameList);

    //CString singleLine;
    //singleLine.Format(_T("List has %d items\r\n"), objNameList.GetSize()); 

    //for (int i=0;i<objNameList.GetSize(); i++)
    //{
    //    singleLine += objNameList[i];
    //    singleLine += _T("\r\n");
    //}
    //AfxMessageBox(singleLine);

    //// now export it to a file
    //NRKSdk.SetStep(_T("Export ASCII Frames"));
    //NRKSdk.SetFilePathArg(_T("ASCII File Path"), _T("C:\\Temp\\MP\\Frames.txt"), FALSE);
    //helper.SetCollectionObjectNameRefListArgHelper(_T("Object List"), objNameList);
    //NRKSdk.SetStringArg(_T("Export Frame Mode"), _T("Fixed XYZ"));
    //NRKSdk.SetBoolArg(_T("Overwrite existing file?"), TRUE);
    //bSendStatus = NRKSdk.ExecuteStep( );

    // Export point group
    //NRKSdk.SetStep(_T("Export ASCII Points"));
    //NRKSdk.SetFilePathArg(_T("ASCII File Path"), _T("C:\\Temp\\MP\\pts.txt"), FALSE);

    //CStringArray grpNameList;
    //grpNameList.Add(_T("B::circle"));
    //helper.SetCollectionGroupNameRefListArgHelper(_T("Group Names to export"), grpNameList);
    //NRKSdk.SetExportDataDelimeterTypeArg(_T("Data Delimiter"), _T("Comma"));
    //NRKSdk.SetExportTargetNameFormatArg(_T("Target Name Format"), _T("Group Target"));
    //NRKSdk.SetCoordinateSystemTypeArg(_T("Desired Coordinate System"), _T("Cartesian"));
    //NRKSdk.SetBoolArg(_T("Include Target Offsets?"), FALSE);
    //NRKSdk.SetBoolArg(_T("Include Target Comments?"), FALSE);
    //NRKSdk.SetBoolArg(_T("Include Timestamps?"), FALSE);
    //NRKSdk.SetBoolArg(_T("Include Tolerances?"), FALSE);
    //NRKSdk.SetBoolArg(_T("Include Coordinate Uncertainties?"), FALSE);
    //NRKSdk.SetBoolArg(_T("Include SA version and frame comments?"), TRUE);
    //NRKSdk.SetBoolArg(_T("Include Axis Comments?"), TRUE);
    //NRKSdk.SetBoolArg(_T("Include Export Format Info?"), TRUE);
    //NRKSdk.SetBoolArg(_T("Include Weights?"), FALSE);
    //NRKSdk.SetBoolArg(_T("Include Measurement Details?"), FALSE);
    //NRKSdk.SetBoolArg(_T("Maximum Precision (Scientific Notation)?"), FALSE);
    //NRKSdk.SetIntegerArg(_T("Decimal Precision"), 6);
    //NRKSdk.SetBoolArg(_T("Append?"), FALSE);
    //bSendStatus = NRKSdk.ExecuteStep( );

    //if (bSendStatus)
    //{
    //    LONG rCode;
    //    NRKSdk.GetMPStepResult(&rCode);
    //    if (rCode == DoneSuccess)
    //    {
    //        TRACE(_T("The operation was performed successfully\n"));
    //    }
    //    else
    //        TRACE(_T("The operation was not successful\n"));
    //}

    //**********************************************************
    // olga 2022.03.02 XIT-2824 - Import ASCII: Predefined Formats
    //**********************************************************
    NRKSdk.SetStep(_T("Import ASCII: Predefined Formats"));
    NRKSdk.SetFilePathArg(_T("ASCII File Path"), _T("C:\\Analyzer Data\\PtOut.txt"), FALSE);
    NRKSdk.SetAsciiFileFormatArg(_T("File Format"), _T("X Y Z"));
    NRKSdk.SetDistanceUnitsArg(_T("Units"), _T("Inches"));
    NRKSdk.SetAngularUnitsArg(_T("Angular Units"), _T("Degrees"));
    NRKSdk.SetCollectionObjectNameArg(_T("Group Name"), _T("A"), _T("my2"));
    NRKSdk.SetBoolArg(_T("Import as Cloud"), FALSE);
    NRKSdk.SetBoolArg(_T("Ensure New Point Group"), TRUE);
    NRKSdk.SetBoolArg(_T("Ensure Unique Names"), TRUE);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == SdkError)
        {
            CStringArray msgs;
            // Something went wrong... check for any messages provided...
            SDKHelper	helper(NRKSdk);
            if (helper.GetMPStepMessagesHelper(msgs))
            {
                CString singleLine;
                for (int i = 0; i < msgs.GetSize(); i++)
                {
                    singleLine += msgs[i];
                    singleLine += _T("\r\n");
                }
                AfxMessageBox(singleLine);
            }
        }
        else
            AfxMessageBox(_T("ASCII Import success!"));
    }
    //**********************************************************
    // olga 2022.03.02 XIT-2824 - Import ASCII: Predefined Formats
    //**********************************************************
    NRKSdk.SetStep(_T("Direct CAD Access"));
    NRKSdk.SetFilePathArg(_T("CAD File Name"), _T("C:\\Analyzer Data\\Sample CAD.CATPart"), FALSE);
    NRKSdk.SetBoolArg(_T("Import Solids"), TRUE);
    NRKSdk.SetBoolArg(_T("Import Surfaces"), TRUE);
    NRKSdk.SetBoolArg(_T("Import Polygonized Surfaces"), TRUE);
    NRKSdk.SetBoolArg(_T("Import Annotations"), TRUE);
    NRKSdk.SetBoolArg(_T("Import Vectors"), TRUE);
    NRKSdk.SetBoolArg(_T("Import Points"), TRUE);
    NRKSdk.SetStringArg(_T("Point Group Name"), _T("CAD pts"));
    NRKSdk.SetBoolArg(_T("Import Attributes/Metadata"), TRUE);
    NRKSdk.SetBoolArg(_T("Import Cooordinate Frames"), TRUE);
    NRKSdk.SetBoolArg(_T("Import Planes"), TRUE);
    NRKSdk.SetBoolArg(_T("Import 3D Curves - Lines"), TRUE);
    NRKSdk.SetBoolArg(_T("Import 3D Curves - Circles"), TRUE);
    NRKSdk.SetBoolArg(_T("Import 3D Curves - General Curves"), TRUE);
    NRKSdk.SetBoolArg(_T("Import Construction Geometry"), FALSE);
    NRKSdk.SetBoolArg(_T("Import Hidden Entities"), FALSE);
    NRKSdk.SetBoolArg(_T("Import all Surfaces as Mesh Graphical Entities"), FALSE);
    NRKSdk.SetBoolArg(_T("Do Not Import Fillets"), FALSE);
    NRKSdk.SetBoolArg(_T("Do Not Import Dittos"), FALSE);
    NRKSdk.SetIntegerArg(_T("Ditto Threshold"), 1);
    NRKSdk.SetBoolArg(_T("Center View on Imported Objects"), TRUE);
    NRKSdk.SetBoolArg(_T("Import into Folders matching CAD file hierarchy"), FALSE);
    NRKSdk.SetBoolArg(_T("Remove Empty Folders"), TRUE);
    NRKSdk.SetIntegerArg(_T("Surface Normals Mode (1 or 2)"), 1);
    NRKSdk.SetBoolArg(_T("Prompt on Missing Components"), TRUE);
    NRKSdk.SetBoolArg(_T("Selective Import"), FALSE);
    NRKSdk.SetBoolArg(_T("Surface Compatibility Mode"), FALSE);
    NRKSdk.SetBoolArg(_T("Explode Surfaces"), FALSE);
    NRKSdk.SetStringArg(_T("CAD File Units (leave blank to use the units specified in the file)"), _T(""));
    NRKSdk.SetBoolArg(_T("Build Callout Views"), TRUE);

    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);

        // Check warnings
        BOOL bWarnings;
        NRKSdk.GetBoolArg(_T("Import Warnings"), &bWarnings);

        if (bWarnings)
        {
            CComBSTR bstrMsg;
            if (NRKSdk.GetStringArg(_T("Import Warning Messages"), &bstrMsg))
            {
                CString str = bstrMsg;
                CString msg;
                msg.Format(_T("Import Warning Messages: %s"), str);
                AfxMessageBox(msg);
            }
            // Must release the BSTR returned.
            bstrMsg.Empty();
        }

        if (rCode == DoneSuccess)
        {
            // The command executed successfully, now get the return values and display to user
            DOUBLE xVal, yVal, zVal;
            if (NRKSdk.GetVectorArg(_T("Extents Min"), &xVal, &yVal, &zVal))
            {
                CString msg;
                msg.Format(_T("Extents Min: %f %f %f"), xVal, yVal, zVal);
                AfxMessageBox(msg);
            }
            if (NRKSdk.GetVectorArg(_T("Extents Max"), &xVal, &yVal, &zVal))
            {
                CString msg;
                msg.Format(_T("Extents Min: %f %f %f"), xVal, yVal, zVal);
                AfxMessageBox(msg);
            }
            AfxMessageBox(_T("CAD Import success!"));
        }
        else
        {
            CStringArray msgs;
            // Something went wrong... check for any messages provided...
            SDKHelper	helper(NRKSdk);
            if (helper.GetMPStepMessagesHelper(msgs))
            {
                CString singleLine;
                for (int i = 0; i < msgs.GetSize(); i++)
                {
                    singleLine += msgs[i];
                    singleLine += _T("\r\n");
                }
                AfxMessageBox(singleLine);
            }
        }
    }
}

//**************************************************
// olga 2021.03.09 XIT-2338 - Theodilite collimation
// Test is based on the SA job attached to JIRA item
// named CollimationMPTest.xit
// Running 3 collimation scenarios:
// - Known Point Collimation
// - Scale Collimation
// - Distance Collimation
//**************************************************
void CSASDKMFCDlg::OnBnClickedButton22()
{
    BOOL bSendStatus = FALSE;
    SDKHelper helper(NRKSdk);

    CStringArray stringList;
    CStringArray objNameList;
    CStringArray instObjList;

    // Set default collection
    NRKSdk.SetStep(_T("Set (or construct) default collection"));
    NRKSdk.SetCollectionNameArg(_T("Collection Name"), _T("Collimation with Known Point"));
    bSendStatus = NRKSdk.ExecuteStep();

    // show point groups
    NRKSdk.SetStep(_T("Show Objects"));
    objNameList.Add(_T("Collimation with Known Point::collimation::Point Group"));
    objNameList.Add(_T("Collimation with Known Point::common pts::Point Group"));
    objNameList.Add(_T("Collimation with Known Point::knownpoints::Point Group"));
    helper.SetCollectionObjectNameRefListArgHelper(_T("Objects To Show"), objNameList);
    bSendStatus = NRKSdk.ExecuteStep();

    // show instruments
    NRKSdk.SetStep(_T("Show/Hide Instruments"));
    instObjList.Add(_T("Collimation with Known Point::0"));
    instObjList.Add(_T("Collimation with Known Point::1"));
    helper.SetColInstIdRefListArgHelper(_T("Instrument IDs"), instObjList);
    NRKSdk.SetBoolArg(_T("Show Instruments?"), TRUE);
    NRKSdk.ExecuteStep();

    // start test "Known Point Collimation"
    NRKSdk.SetStep(_T("Notify User Text Array"));
    stringList.RemoveAll();
    stringList.Add(_T("Known Point Collimation... Go? "));
    helper.SetEditTextArgHelper(_T("Notification Text"), stringList);
    NRKSdk.SetFontTypeArg(_T("Font"), _T("MS Shell Dlg"), 12, 0, 0, 0);
    NRKSdk.SetBoolArg(_T("Auto expand to fit text?"), FALSE);
    NRKSdk.SetIntegerArg(_T("Display Timeout"), 0);
    bSendStatus = NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Collimation"));
    NRKSdk.SetColInstIdArg(_T("Stationary Instrument ID"), _T(""), 0);
    NRKSdk.SetColInstIdArg(_T("Moving Instrument ID"), _T(""), 1);
    NRKSdk.SetPointNameArg(_T("Collimation Point"), _T(""), _T("collimation"), _T("c0-1"));
    NRKSdk.SetBoolArg(_T("Zero Moving Instrument"), FALSE);
    // Available options: 
    // "Full Collimation", "No-Tilt Collimation", 
    NRKSdk.SetCollimationTypeArg(_T("Collimation Tilt Mode"), _T("Full Collimation"));
    // Available options: 
    // "Determined By Value", "Determined From Scale", "Determined From Known Point", 
    NRKSdk.SetCollimationBaselineTypeArg(_T("Collimation Baseline Mode"), _T("Determined From Known Point"));
    NRKSdk.SetDoubleArg(_T("Baseline Distance"), 0.000000);
    NRKSdk.SetPointNameArg(_T("Scale Point 1"), _T(""), _T(""), _T(""));
    NRKSdk.SetPointNameArg(_T("Scale Point 2"), _T(""), _T(""), _T(""));
    NRKSdk.SetPointNameArg(_T("Not Measured By Moving Instrument"), _T(""), _T("known"), _T("w3"));
    NRKSdk.SetPointNameArg(_T("As Measured By Moving Instrument"), _T(""), _T("known"), _T("w3"));
    bSendStatus = NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Notify User Text Array"));
    stringList.RemoveAll();
    stringList.Add(_T("Known Point Collimation... DONE. "));
    helper.SetEditTextArgHelper(_T("Notification Text"), stringList);
    NRKSdk.SetFontTypeArg(_T("Font"), _T("MS Shell Dlg"), 12, 0, 0, 0);
    NRKSdk.SetBoolArg(_T("Auto expand to fit text?"), FALSE);
    NRKSdk.SetIntegerArg(_T("Display Timeout"), 0);
    bSendStatus = NRKSdk.ExecuteStep();


    ///////////////////////////////////////////////////////////////////////
    // prepare to next test - hide data from the previous test
    NRKSdk.SetStep(_T("Hide Objects"));
    objNameList.RemoveAll();
    objNameList.Add(_T("Collimation with Known Point::collimation::Point Group"));
    objNameList.Add(_T("Collimation with Known Point::common pts::Point Group"));
    objNameList.Add(_T("Collimation with Known Point::knownpoints::Point Group"));
    helper.SetCollectionObjectNameRefListArgHelper(_T("Objects To Hide"), objNameList);
    bSendStatus = NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Show/Hide Instruments"));
    instObjList.RemoveAll();
    instObjList.Add(_T("Collimation with Known Point::0"));
    instObjList.Add(_T("Collimation with Known Point::1"));

    helper.SetColInstIdRefListArgHelper(_T("Instrument IDs"), instObjList);
    NRKSdk.SetBoolArg(_T("Show Instruments?"), FALSE);
    NRKSdk.ExecuteStep();

    // change default collection
    NRKSdk.SetStep(_T("Set (or construct) default collection"));
    NRKSdk.SetCollectionNameArg(_T("Collection Name"), _T("Collimation with Scale"));
    bSendStatus = NRKSdk.ExecuteStep();

    // show point groups
    NRKSdk.SetStep(_T("Show Objects"));
    objNameList.RemoveAll();
    objNameList.Add(_T("Collimation with Scale::collimation::Point Group"));
    objNameList.Add(_T("Collimation with Scale::common pts::Point Group"));
    objNameList.Add(_T("Collimation with Scale::Mirrors::Point Group"));
    objNameList.Add(_T("Collimation with Scale::WORLD (imported)::Frame"));

    helper.SetCollectionObjectNameRefListArgHelper(_T("Objects To Show"), objNameList);
    bSendStatus = NRKSdk.ExecuteStep();

    // show instruments
    NRKSdk.SetStep(_T("Show/Hide Instruments"));
    instObjList.RemoveAll();
    instObjList.Add(_T("Collimation with Scale::0"));
    instObjList.Add(_T("Collimation with Scale::1"));
    helper.SetColInstIdRefListArgHelper(_T("Instrument IDs"), instObjList);
    NRKSdk.SetBoolArg(_T("Show Instruments?"), TRUE);
    bSendStatus = NRKSdk.ExecuteStep();

    // start Scale Collimation
    NRKSdk.SetStep(_T("Notify User Text Array"));
    stringList.RemoveAll();
    stringList.Add(_T("Scale Collimation... Go? "));
    helper.SetEditTextArgHelper(_T("Notification Text"), stringList);
    NRKSdk.SetFontTypeArg(_T("Font"), _T("MS Shell Dlg"), 8, 0, 0, 0);
    NRKSdk.SetBoolArg(_T("Auto expand to fit text?"), FALSE);
    NRKSdk.SetIntegerArg(_T("Display Timeout"), 0);
    bSendStatus = NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Collimation"));
    NRKSdk.SetColInstIdArg(_T("Stationary Instrument ID"), _T(""), 0);
    NRKSdk.SetColInstIdArg(_T("Moving Instrument ID"), _T(""), 1);
    NRKSdk.SetPointNameArg(_T("Collimation Point"), _T(""), _T("collimation"), _T("c0-1"));
    NRKSdk.SetBoolArg(_T("Zero Moving Instrument"), FALSE);
    // Available options: 
    // "Full Collimation", "No-Tilt Collimation", 
    NRKSdk.SetCollimationTypeArg(_T("Collimation Tilt Mode"), _T("Full Collimation"));
    // Available options: 
    // "Determined By Value", "Determined From Scale", "Determined From Known Point", 
    NRKSdk.SetCollimationBaselineTypeArg(_T("Collimation Baseline Mode"), _T("Determined From Scale"));
    NRKSdk.SetDoubleArg(_T("Baseline Distance"), 143.500000);
    NRKSdk.SetPointNameArg(_T("Scale Point 1"), _T(""), _T("common pts"), _T("w3"));
    NRKSdk.SetPointNameArg(_T("Scale Point 2"), _T(""), _T("mirrors"), _T("gimbal"));
    NRKSdk.SetPointNameArg(_T("Not Measured By Moving Instrument"), _T(""), _T(""), _T(""));
    NRKSdk.SetPointNameArg(_T("As Measured By Moving Instrument"), _T(""), _T(""), _T(""));
    bSendStatus = NRKSdk.ExecuteStep();


    // start Scale Collimation
    NRKSdk.SetStep(_T("Notify User Text Array"));
    stringList.RemoveAll();
    stringList.Add(_T("Scale Collimation...DONE "));
    helper.SetEditTextArgHelper(_T("Notification Text"), stringList);
    NRKSdk.SetFontTypeArg(_T("Font"), _T("MS Shell Dlg"), 12, 0, 0, 0);
    NRKSdk.SetBoolArg(_T("Auto expand to fit text?"), FALSE);
    NRKSdk.SetIntegerArg(_T("Display Timeout"), 0);
    bSendStatus = NRKSdk.ExecuteStep();


    ///////////////////////////////////////////////////////////////////////
    NRKSdk.SetStep(_T("Hide Objects"));
    objNameList.RemoveAll();
    objNameList.Add(_T("Collimation with Scale::collimation::Point Group"));
    objNameList.Add(_T("Collimation with Scale::common pts::Point Group"));
    objNameList.Add(_T("Collimation with Scale::Mirrors::Point Group"));
    objNameList.Add(_T("Collimation with Scale::WORLD (imported)::Frame"));
    helper.SetCollectionObjectNameRefListArgHelper(_T("Objects To Hide"), objNameList);
    NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Show/Hide Instruments"));
    instObjList.RemoveAll();
    instObjList.Add(_T("Collimation with Scale::0"));
    instObjList.Add(_T("Collimation with Scale::1"));

    helper.SetColInstIdRefListArgHelper(_T("Instrument IDs"), instObjList);
    NRKSdk.SetBoolArg(_T("Show Instruments?"), FALSE);
    NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Set (or construct) default collection"));
    NRKSdk.SetCollectionNameArg(_T("Collection Name"), _T("Collimation with Distance"));
    NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Show Objects"));
    objNameList.RemoveAll();
    objNameList.Add(_T("Collimation with Distance::collimation::Point Group"));
    helper.SetCollectionObjectNameRefListArgHelper(_T("Objects To Show"), objNameList);
    NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Show/Hide Instruments"));
    instObjList.RemoveAll();
    instObjList.Add(_T("Collimation with Distance::0"));
    instObjList.Add(_T("Collimation with Distance::1"));
    helper.SetColInstIdRefListArgHelper(_T("Instrument IDs"), instObjList);
    NRKSdk.SetBoolArg(_T("Show Instruments?"), TRUE);
    NRKSdk.ExecuteStep();

    // start the test
    NRKSdk.SetStep(_T("Notify User Text Array"));
    stringList.RemoveAll();
    stringList.Add(_T("Distance Collimation... Go? "));
    helper.SetEditTextArgHelper(_T("Notification Text"), stringList);
    NRKSdk.SetFontTypeArg(_T("Font"), _T("MS Shell Dlg"), 12, 0, 0, 0);
    NRKSdk.SetBoolArg(_T("Auto expand to fit text?"), FALSE);
    NRKSdk.SetIntegerArg(_T("Display Timeout"), 0);
    bSendStatus = NRKSdk.ExecuteStep();

    NRKSdk.SetStep(_T("Collimation"));
    NRKSdk.SetColInstIdArg(_T("Stationary Instrument ID"), _T(""), 0);
    NRKSdk.SetColInstIdArg(_T("Moving Instrument ID"), _T(""), 1);
    NRKSdk.SetPointNameArg(_T("Collimation Point"), _T(""), _T("collimation"), _T("c0-1"));
    NRKSdk.SetBoolArg(_T("Zero Moving Instrument"), FALSE);
    // Available options: 
    // "Full Collimation", "No-Tilt Collimation", 
    NRKSdk.SetCollimationTypeArg(_T("Collimation Tilt Mode"), _T("Full Collimation"));
    // Available options: 
    // "Determined By Value", "Determined From Scale", "Determined From Known Point", 
    NRKSdk.SetCollimationBaselineTypeArg(_T("Collimation Baseline Mode"), _T("Determined By Value"));
    NRKSdk.SetDoubleArg(_T("Baseline Distance"), 63.000000);
    NRKSdk.SetPointNameArg(_T("Scale Point 1"), _T(""), _T(""), _T(""));
    NRKSdk.SetPointNameArg(_T("Scale Point 2"), _T(""), _T(""), _T(""));
    NRKSdk.SetPointNameArg(_T("Not Measured By Moving Instrument"), _T(""), _T(""), _T(""));
    NRKSdk.SetPointNameArg(_T("As Measured By Moving Instrument"), _T(""), _T(""), _T(""));
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            TRACE(_T("The operation was performed successfully\n"));
        }
        else
            TRACE(_T("The operation was not successful\n"));
    }
    NRKSdk.SetStep(_T("Notify User Text Array"));
    stringList.RemoveAll();
    stringList.Add(_T("Distance Collimation...DONE "));
    helper.SetEditTextArgHelper(_T("Notification Text"), stringList);
    NRKSdk.SetFontTypeArg(_T("Font"), _T("MS Shell Dlg"), 12, 0, 0, 0);
    NRKSdk.SetBoolArg(_T("Auto expand to fit text?"), FALSE);
    NRKSdk.SetIntegerArg(_T("Display Timeout"), 0);
    bSendStatus = NRKSdk.ExecuteStep();

}

//**********************************************************
// olga XIT-2450 2021.05.07 - testing folders' operations
//**********************************************************
void CSASDKMFCDlg::OnBnClickedButton23()
{
    BOOL bSendStatus = FALSE;
    SDKHelper helper(NRKSdk);

    // Test 1 - "Get Folder Collection"
    NRKSdk.SetStep(_T("Get Folder Collections"));
    NRKSdk.SetStringArg(_T("Folder Path"), _T("Folder"));

    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            SDKHelper helper(NRKSdk);
            CStringArray colNames;

            // Get and display the collection names to the user
            if (helper.GetStringRefListArgHelper(_T("Collection List"), colNames))
            {
                for (INT_PTR row = 0; row < colNames.GetSize(); row++)
                {
                    TRACE1("%s\n", colNames[row]);
                }
                TRACE("\n");
            }
        }
    }
}

//****************************************************************************
// olga XIT-2789 2022.02.08 - Test to verify support of added new MP arguments
// - "Fit Constraint Options (Scalar Type)" MP argument 
// - "Axis Identifier" MP argument"
//****************************************************************************
void CSASDKMFCDlg::OnBnClickedButton24()
{
    BOOL bSendStatus = FALSE;
    SDKHelper helper(NRKSdk);

    // Test "Axis Identifier" MP argument
    NRKSdk.SetStep(_T("Construct Frame - Copy And Make Left Handed"));
    NRKSdk.SetCollectionObjectNameArg(_T("Reference Frame"), _T("A"), _T("WORLD"));
    NRKSdk.SetCollectionObjectNameArg(_T("Frame Name (Optional)"), _T(""), _T("NewFrame"));
    NRKSdk.SetAxisNameArg(_T("Axis to reverse"), _T("Z Axis"));
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            TRACE(_T("The operation was performed successfully\n"));
        }
        else
            TRACE(_T("The operation was not successful\n"));
    }
    //////////////////////////////////////////////////////////////
    // "Fit Constraint Options (Scalar Type)"
    NRKSdk.SetStep(_T("Make Scalar Fit Constraint"));
    NRKSdk.SetBoolArg(_T("Use High Limit"), TRUE);
    NRKSdk.SetDoubleArg(_T("High Limit"), 0.700000);
    NRKSdk.SetBoolArg(_T("Use Low Limit"), TRUE);
    NRKSdk.SetDoubleArg(_T("Low Limit"), 0.010000);
    bSendStatus = NRKSdk.ExecuteStep();

    BOOL	bUseHigh;
    DOUBLE	highTol;
    BOOL	bUseLow;
    DOUBLE	lowTol;
    NRKSdk.GetFitConstraintScalarOptionsArg(_T("Resultant Constraint Options"), &bUseHigh, &highTol, &bUseLow, &lowTol);

    // Set "Fit Constraint Options (Scalar Type)"
    NRKSdk.SetStep(_T("Set Relationship Fit Constraints (Scalar Type)"));
    NRKSdk.SetCollectionObjectNameArg(_T("Relationship Name"), _T("A"), _T("Canopy"));
    NRKSdk.SetFitConstraintScalarOptionsArg(_T("Fit Constraint Options"), bUseHigh, highTol, bUseLow, lowTol);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            TRACE(_T("The operation was performed successfully\n"));
        }
        else
            TRACE(_T("The operation was not successful\n"));
    }

    // Get "Fit Constraint Options (Scalar Type)"
    NRKSdk.SetStep(_T("Get Relationship Fit Constraints (Scalar Type)"));
    NRKSdk.SetCollectionObjectNameArg(_T("Relationship Name"), _T("A"), _T("Canopy"));
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            TRACE(_T("The operation was performed successfully\n"));


            NRKSdk.GetFitConstraintScalarOptionsArg(_T("Resultant Constraint Options"), &bUseHigh, &highTol, &bUseLow, &lowTol);
            CString m;
            m.Format(_T("High [%d, %f]\nLow [%d, %f]"), bUseHigh, highTol, bUseLow, lowTol);
            AfxMessageBox(m);
        }
        else
            TRACE(_T("The operation was not successful\n"));
    }
}

//****************************************************************************
// olga XIT-3112 2022.11.01 - test to "Export Vector Container to Excel File"
//****************************************************************************
void CSASDKMFCDlg::OnBnClickedButton25()
{
    BOOL bSendStatus = FALSE;
    SDKHelper helper(NRKSdk);

    CString path = _T("C:\\Analyzer Data\\ExcelVG_SDK.csv");
    NRKSdk.SetStep(_T("Export Vector Container to Excel File"));
    NRKSdk.SetFilePathArg(_T("Excel File Path"), path, FALSE);

    CStringArray vgNameList;
    vgNameList.Add(_T("A::Random: VG"));

    helper.SetCollectionVectorGroupNameRefListArgHelper(_T("Vector group(s) to export"), vgNameList);
    NRKSdk.SetBoolArg(_T("Overwrite existing file? (FALSE = No Export)"), TRUE);
    // Available options: 
    // "Collection Group Vector", "Group Vector", "Vector", "None", 
    NRKSdk.SetExportVectorNameFormatArg(_T("Vector Name Format"), _T("Collection Group Vector"));
    NRKSdk.SetBoolArg(_T("Include Vector Length?"), TRUE);
    bSendStatus = NRKSdk.ExecuteStep();

    if (bSendStatus)
    {
        LONG rCode;
        NRKSdk.GetMPStepResult(&rCode);
        if (rCode == DoneSuccess)
        {
            TRACE(_T("The operation was performed successfully\n"));

            // open exported file in Excel 
            NRKSdk.SetStep(_T("Run Another Program"));
            NRKSdk.SetFilePathArg(_T("Program Path"), path, FALSE);
            NRKSdk.SetStringArg(_T("Command Line Arguments (optional)"), _T(""));
            NRKSdk.SetBoolArg(_T("Wait For Program Completion"), FALSE);
            NRKSdk.ExecuteStep();
        }
        else
            TRACE(_T("The operation was not successful\n"));
    }
}