
// SASDKMFCDlg.h : header file
//

#include "CSpatialAnalyzerSDK.h"

#pragma once

class CSASDKMFCDlgAutoProxy;


// CSASDKMFCDlg dialog
class CSASDKMFCDlg : public CDialogEx
{
	DECLARE_DYNAMIC(CSASDKMFCDlg);
	friend class CSASDKMFCDlgAutoProxy;

// Construction
public:
	CSASDKMFCDlg(CWnd* pParent = nullptr);	// standard constructor
	virtual ~CSASDKMFCDlg();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_SASDKMFC_DIALOG };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support

	enum MPStatus
	{
		SdkError = -1,
		Undone = 0,
		InProgress = 1,
		DoneSuccess = 2,
		DoneFatalError = 3,
		DoneMinorError = 4,
		CurrentTask = 5
	};

// Implementation
protected:
	CSASDKMFCDlgAutoProxy* m_pAutoProxy;
	HICON m_hIcon;

	BOOL CanExit();
	BOOL m_SDKDispatchCreated;
	BOOL m_SDKConnected;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnClose();
	virtual void OnOK();
	virtual void OnCancel();
	DECLARE_MESSAGE_MAP()

private:
	CSpatialAnalyzerSDK NRKSdk;

public:

	afx_msg void OnBnClickedConnect();
	afx_msg void OnBnClickedDisconnect();   // olga 2018.06.19 XIT-849

	afx_msg void OnBnClickedTest();
	afx_msg void OnBnClickedGetTransform();
	afx_msg void OnBnClickedButton4();
	afx_msg void OnBnClickedButton5();
	afx_msg void OnBnClickedButton6();
	afx_msg void OnBnClickedButton7();
	afx_msg void OnBnClickedButton8();
	afx_msg void OnBnClickedButton9();
	afx_msg void OnBnClickedButton10();          // olga 2015.09.22 mantis #7823 - check math functions
	afx_msg void OnBnClickedButton11();          // olga 2017.02.28 XIT-311 - check math functions
	afx_msg void OnBnClickedButton12();          // olga 2017.05.18 XIT-659 - duplicated object names case
	afx_msg void OnBnClickedButton13();          // olga 2017.12.08 XIT-917 - transition to new SA Colorizer
	afx_msg void OnBnClickedButton14();

	afx_msg void OnBnClickedButton16();
	afx_msg void OnBnClickedButton17();
	afx_msg void OnBnClickedButton18();
	afx_msg void OnBnClickedButton19();
	afx_msg void OnBnClickedButton20();
	afx_msg void OnBnClickedButton21();          // olga 2020.10.22 XIT-2275 - Export ASCII Frames verification
	afx_msg void OnBnClickedButton22();
	afx_msg void OnBnClickedButton23();         // olga 2021.05.07 XIT-2450 - for testing folders' operations
	afx_msg void OnBnClickedButton24();
	afx_msg void OnBnClickedButton25();
};
